<?php
/**
 * Шаблон блока категории баннеров
 * 
 * Шаблонный тег <insert name="show_category" module="bs" [cat_id="номер"] [count="all|количество"] [sort="date|rand"] [template="шаблон"]>:
 * 
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2023 OOO «Диафан» (http://www.diafan.ru/)
 */

if (! defined('DIAFAN'))
{
	$path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}



if (empty($result['rows']))
{
	return false;
}

echo '<section class="block-d block-d_bs block-d_bs_cat block-d_bs_cat'.$result['id'].'">';

//скрытая форма для отправки статистики по кликам
if (! isset($GLOBALS['include_bs_js']))
{
	$GLOBALS['include_bs_js'] = true;

	echo
	'<form method="POST" enctype="multipart/form-data" action="" class="ajax js_bs_form bs_form _hidden">
		<input type="hidden" name="module" value="bs">
		<input type="hidden" name="action" value="click">
		<input type="hidden" name="banner_id" value="0">
	</form>';
}

if (! empty($result['name']))
{
	echo '<header class="block-d__name">'.$result['name'].'</header>';
}

if (! empty($result['images']))
{
	echo '<div class="block-d__images _images">';
	foreach ($result['images'] as $img)
	{
		switch ($img['type'])
		{
			case 'animation':
				echo '<a href="'.BASE_PATH.$img["link"].'" data-fancybox="gallery'.$result["id"].'bs">';
				break;
			case 'big_image':
				echo '<a href="'.BASE_PATH.$img["link"].'" rel="big_image" width="'.$img["link_width"].'" height="'.$img["link_height"].'">';
				break;
			default:
				echo '<a href="'.BASE_PATH_HREF.$img["link"].'">';
				break;
		}
		if ($img['source'])
		{
			echo $img['source'];
		}
		else
		{
			echo '<img src="'.$img['src'].'" width="'.$img['width'].'" height="'.$img['height'].'" alt="'.$img['alt'].'" title="'.$img['title'].'">';
		}
		echo '</a>';
	}
	echo '</div>';
}

if (! empty($result['text']))
{
	echo '<div class="block-d__text _text">'.$result['text'].'</div>';
}

echo '<div class="block-d__list _list">';
foreach ($result['rows'] as $row)
{
	echo '<article class="element-d element-d_bs element-d_bs_item">';

	echo '<div class="element-d__images">';
	if (! empty($row['link']))
	{
		echo '<a href="'.$row['link'].'" class="js_bs_counter bs_counter" rel="'.$row['id'].'"'.(! empty($row['target_blank']) ? ' target="_blank"' : '').'>';
	}
	//вывод баннера в виде html разметки
	if (! empty($row['html']))
	{
		echo $row['html'];
	}
	//вывод баннера в виде изображения
	if (! empty($row['image']))
	{
		echo '<img src="'.BASE_PATH.USERFILES.'/bs/'.$row['image'].'" alt="'.(! empty($row['alt']) ? $row['alt'] : '').'" title="'.(! empty($row['title']) ? $row['title'] : '').'">';
	}
	if (! empty($row['link']))
	{
		echo '</a>';
	}
	echo '</div>';

	echo '<div class="element-d__details details-d">';
	if (! empty($row['name']))
	{
		echo '<div class="detail-d detail-d_name">'.$row['name'].'</div>';
	}
	if (! empty($row['text']))
	{
		echo '<div class="detail-d detail-d_text _text">'.$row['text'].'</div>';
	}
	echo '</div>';

	echo '</article>';
}
echo '</div>';
echo '</section>';
