<?php
/**
 * Обработка POST-запросов бэкенда
 *
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2021 OOO «Диафан» (http://www.diafan.ru/)
 */

if (! defined('DIAFAN'))
{
    $path = __FILE__;
    while(! file_exists($path.'/includes/404.php'))
    {
        $parent = dirname($path);
        if($parent == $path) exit;
        $path = $parent;
    }
    include $path.'/includes/404.php';
}



class Captcha_kcaptcha_action extends Action
{
    /**
	 * Пометить, что на клиенте отработал AJAX
	 * 
	 * @return void
	 */
	public function verify()
	{
        $this->result['result'] = 'success';

        if (! empty($_POST['cfio']) || empty($_POST['captchaint']) || empty($_POST['captchapin']))
        {
            return;
        }
        $duration = $this->diafan->configmodules('kcaptcha_duration', 'captcha');
        if (empty($duration))
        {
            $duration = 5;
        }
        $c = time() - mktime(0,0,0);
        if ($_POST['captchapin'] > $c || $c - $_POST['captchapin'] < $duration)
        {
            return;
        }
        $tag = $this->get_form_tag();
        $_SESSION['captcha_verify'][$tag][$_POST['captchaint']] = true;
    }
}
