<?php
/**
 * Настройки капчи «Код на картинке»
 * 
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2019 OOO «Диафан» (http://www.diafan.ru/)
 */

if (! defined('DIAFAN'))
{
	$path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}

class Captcha_kcaptcha_admin extends Diafan
{
	public $config = array(
		'name' => 'Код + проверка на ботов',
		'params' => array(
			'mode' => array(
				'type' => 'select',
				'name' => 'Режим',
				'select' => array(
					'' => 'По умолчанию',
					'nocode' => 'Без кода',
				),
			),
			'duration' => array(
				'type' => 'function',
				'name' => 'Длительность проверки',
				'help' => 'Длительность проверки в секундах',
			),
		),
	);

	/**
	 * Обработчик представления поля
	 *
	 * @param string $value — текущее значение
	 * @param array $values — все значения
	 * @return void
	 */
	public function edit_variable_duration($value, $values)
	{
		$name = $this->config['params']['duration']['name'];
		$help = $this->config['params']['duration']['help'];
		$default = 5;

		$value = intval($value);

		echo '
		<div class="unit">
			<div class="infofield">'.$this->diafan->_($name).($help ? $this->diafan->help($help) : '').'</div>
			<input type="text" class="number" name="kcaptcha_duration" value="'.($value > 0 ? $value : $default).'" placeholder="5">
		</div>';
	}

	/**
	 * Обработчик представления поля
	 *
	 * @return integer
	 */
	public function save_variable_duration()
	{
		return $this->diafan->filter($_POST, 'int', 'kcaptcha_duration');
	}
}
