<?php
/**
 * Настройки капчи «Yandex SmartCaptcha»
 * 
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2024 OOO «Диафан» (http://www.diafan.ru/)
 */

if (! defined('DIAFAN'))
{
	$path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}



class Captcha_yacaptcha_admin extends Diafan
{
	public $config = array(
		'name' => 'Yandex SmartCaptcha',
		'params' => array(
			'public_key' => array(
				'type' => 'text',
				'name' => 'Ключ клиента для сервиса <a href="https://console.yandex.cloud/" target="_blank">Yandex SmartCaptcha</a>',
				'help' => 'Параметр выводится, если в поле «Тип» выбрано «Yandex SmartCaptcha».',
			),
			'private_key' => array(
				'type' => 'text',
				'name' => 'Ключ сервера для сервиса <a href="https://console.yandex.cloud/" target="_blank">Yandex SmartCaptcha</a>',
				'help' => 'Параметр выводится, если в поле «Тип» выбрано «Yandex SmartCaptcha».',
			),
			'mode' => array(
				'type' => 'select',
				'name' => 'Режим',
				'select' => array(
					'' => 'Я не робот',
					'invisible' => 'Невидимка',
				),
			),
		),
	);
}
