<?php
/**
 * Контроллер модуля
 *
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2021 OOO «Диафан» (http://www.diafan.ru/)
 */

if (! defined('DIAFAN'))
{
	$path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}



class Captcha extends Controller
{
	/**
	 * Обработка POST-запросов
	 */
	public function action()
	{
		$backend = preg_replace('/[^a-z0-9_]+/', '', $this->diafan->filter($_POST, 'string', 'backend'));
		$action  = preg_replace('/[^a-z0-9_]+/', '', $this->diafan->filter($_POST, 'string', 'action'));

		if ($backend && $action)
		{
			$delegate_name = 'Captcha_'.$backend.'_action';
			$delegate_path = 'modules/captcha/backend/'.$backend.'/captcha.'.$backend.'.action.php';
	
			if (Custom::exists($delegate_path))
			{
				Custom::inc($delegate_path);
	
				if (class_exists($delegate_name))
				{
					$delegate = new $delegate_name($this->diafan);
					if (is_callable(array($delegate, $action)))
					{
						call_user_func_array(array(&$delegate, $action), array());
						$this->action->result = $delegate->result;
					}
				}
			}
		}
	}
}
