<?php
/**
 * Шаблон таблицы с товарами в корзине
 *
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2019 OOO «Диафан» (http://www.diafan.ru/)
 */

if (! defined('DIAFAN')) {
	$path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}



echo '<div class="table-d table-d_cart table-d_sm table-d_md table-d_lg">';

//товары
if (! empty($result["rows"]))
{
	echo '<section class="table-d__section table-d__goods">
	<div class="table-d__rows table-d__title">
		<div class="table-d__row">
			<h4 class="cell-d cell-d_title">'.$this->diafan->_('Товары').'</h4>
		</div>
	</div>
	<div class="table-d__rows table-d__enum">';
	foreach ($result["rows"] as $row)
	{
		echo
		'<div class="table-d__row table-d__good js_cart_item">';

			echo '<div class="cell-d cell-d_images">';
			if (! empty($row["img"]))
			{
				echo '<a class="_fit" href="'.BASE_PATH_HREF.$row["link"].'"><img src="'.$row["img"]["src"].'" width="'.$row["img"]["width"].'" height="'.$row["img"]["height"].'" alt="'.$row["img"]["alt"].'" title="'.$row["img"]["title"].'"></a>';
			}
			else
			{
				echo '<a href="'.BASE_PATH_HREF.$row["link"].'"><figure class="_dummyimage"></figure></a>';
			}
			if ($result['discount'])
			{
				echo
				'<div class="discounts-d discounts-d_stick">
					<div class="discount-d" title="'.$this->diafan->_('Скидка', false).'">
						<span class="discount-d__num">-';
						if ($row['percent'])
						{
							echo $row['percent'].'%';
						}
						else
						{
							echo $row['discount_summ'];
						}
						echo '</span>';
						if (! $row['percent'])
						{
							echo '<span class="discount-d__cur">'.$result['currency'].'</span>';
						}
						echo
					'</div>
				</div>';
			}
			echo '</div>';

			echo
			'<div class="cell-d cell-d_details details-d">';
				echo
				'<div class="detail-d detail-d_name">
					<a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["good_name"].'</a>
				</div>';
				if(! empty($row["params_name"]))
				{
					echo '<div class="detail-d detail-d_params">';
					foreach($row["params_name"] as $p)
					{
						echo
						'<div class="param-d">
							<span class="param-d__name">'.$p["name"].':</span>
							<strong class="param-d__value">'.$p["value"].'</strong>
						</div>';
					}
					echo '</div>';
				}
				if(! empty($row['elements_good_set']))
				{
					echo
					'<div class="detail-d detail-d_good-set">
						<span class="detail-d__name">'.$this->diafan->_('Набор').':</span>
						<strong class="detail-d__content">';
							foreach ($row['elements_good_set'] as $i => $element)
							{
								echo '<a href="'.BASE_PATH_HREF.$element['link'].'">'.$element['name'].'</a>';

								if ($i < count($row['elements_good_set']) - 1)
								{
									echo ', ';
								}
							}
							echo
						'</strong>
					</div>';
				}
				if($row["additional_cost"])
				{
					echo '<div class="detail-d detail-d_additions">';
					foreach($row["additional_cost"] as $a)
					{
						echo
						'<div class="addition-d">
							<span class="addition-d__name">'.$a["name"].':</span>';
							if($a["summ"])
							{
								echo '
								<span class="addition-d__content"> +
									<strong class="price-d">
										<span class="price-d__num">'.$a["format_summ"].'</span>
										<span class="price-d__cur">'.$result["currency"].'</span>
									</strong>
								</span>';
							}
							echo
						'</div>';
					}
					echo '</div>';
				}
				echo
			'</div>';

			echo '<div class="cell-d cell-d_count">';
			if(empty($result["hide_form"]))
			{
				echo
				'<div class="count-d js_cart_count" title="'.$this->diafan->_('Количество', false).'">
					<div class="count-d__control">
						<button class="count-d__dec fas fa-minus js_cart_count_minus" type="button"></button>
						<input name="editshop'.$row["id"].'" class="count-d__input js_count_input" type="text" value="'.$row["count"].'" data-min="0" data-max="'.$row["price_count"].'">
						<button class="count-d__inc fas fa-plus js_cart_count_plus" type="button"></button>
					</div>
				</div>';
			}
			else
			{
				echo $row["count"];
			}
			echo '</div>';

			echo '<div class="cell-d cell-d_unit">';
			echo $row["measure_unit"] ? $row["measure_unit"] : $this->diafan->_('шт.');
			echo '</div>';

			echo
			'<div class="cell-d cell-d_sum">
				<strong class="price-d price-d_fact">
					<span class="price-d__num">'.$row["summ"].'</span>
					<span class="price-d__cur">'.$result["currency"].'</span>
				</strong>';
				if ($result['discount'])
				{
					if ($row['old_price'])
					{
						echo '
						<span class="price-d price-d_old">
							<span class="price-d__num">'.($row['old_summ']).'</span>
							<span class="price-d__cur">'.$result['currency'].'</span>
						</span>';
					}
				}
				echo 
			'</div>';
			if ($this->diafan->_site->theme('show_wishlist'))
			{
				echo
				'<div class="cell-d cell-d_wishlist">
					<span class="wheart-d" title="'.$this->diafan->_('В избранное', false).'">
						<input class="wheart-d__input" type="checkbox" id="wish'.$row["id"].'" name="wishlist'.$row["id"].'" value="1">
						<label class="wheart-d__icon icon-d far fa-heart js_cart_wishlist" for="wish'.$row["id"].'" data-confirm="'.$this->diafan->_('Вы действительно хотите переместить товар из корзины в избранное?', false).'"></label>
					</span>
				</div>';
			}
			echo
			'<div class="cell-d cell-d_remove">
				<span class="remover-d" title="'.$this->diafan->_('Убрать', false).'">
					<input class="remover-d__input" type="checkbox" id="rem'.$row["id"].'" name="del'.$row["id"].'" value="1">
					<label class="remover-d__icon icon-d far fa-times-circle js_cart_remove" for="rem'.$row["id"].'" data-confirm="'.$this->diafan->_('Вы действительно хотите удалить товар из корзины?', false).'"></label>
				</span>
			</div>';

			echo
		'</div>';
	}
	echo '</div>';

	// Скидочный купон. Шаблон, встроенный в форму корзины
	// echo $this->htmleditor('<insert name="show_add_coupon" module="shop" template="cart">');

	// общая скидка от объема
	if(! empty($result["discount_total"]))
	{
		echo
		'<div class="table-d__rows table-d__discounts">';
			echo
			'<div class="table-d__row table-d__discount">
				<div class="cell-d cell-d_total-discount">
					<strong class="price-d">
						<span class="price-d__name">'.$this->diafan->_('Скидка').':</span>
						<span class="price-d__num">';
							if($result["discount_total"]["percent"])
							{
								echo $result["discount_total"]["percent"].'%';
							}
							else
							{
								echo $result["discount_total"]["discount_summ"];
							}
							echo
						'</span>';
						if(! $result["discount_total"]["percent"])
						{
							echo  ' <span class="price-d__cur">'.$result["currency"].'</span>';
						}
						echo
					'</strong>
				</div>
			</div>';
			echo
		'</div>';
	}

	// следующая скидка
	if (! empty($result["discount_next"]))
	{
		echo
		'<div class="table-d__rows table-d__promises">';
			echo
			'<div class="table-d__row table-d__promise">
				<div class="cell-d cell-d_promise">';
					if(! empty($result["discount_next"]) && empty($result["hide_form"]))
					{
						if($result["discount_next"]["percent"])
						{
							$discount = $result["discount_next"]["percent"].'%';
						}
						else
						{
							$discount = $result["discount_next"]["discount_summ"].' '.$result["currency"];
						}
						echo $this->diafan->_('До скидки %s осталось %s', true, $discount, $result["discount_next"]["summ"].' '.$result["currency"]);
					}
					echo
				'</div>
			</div>';
			echo
		'</div>';
	}

	//итоговая строка для товаров
	echo
	'<div class="table-d__rows table-d__total table-d__total_goods">';
		echo
		'<div class="table-d__row">
			<div class="cell-d cell-d_images"></div>
			<div class="cell-d cell-d_details cell-d_title">'.$this->diafan->_('Итого за товары').':</div>
			<div class="cell-d cell-d_sum">
				<strong class="price-d">
					<span class="price-d__num">'.$result["summ_goods"].'</span>
					<span class="price-d__cur">'.$result["currency"].'</span>
				</strong>';
				if(! empty($result["old_summ_goods"]))
				{
					echo '
					<strong class="price-d price-d_old">
						<span class="price-d__num">'.$result["old_summ_goods"].'</span>
						<span class="price-d__cur">'.$result["currency"].'</span>
					</strong>';
				}
				echo
			'</div>';
			if ($this->diafan->_site->theme('show_wishlist'))
			{
				echo '<div class="cell-d cell-d_wishlist"></div>';
			}
			echo
			'<div class="cell-d cell-d_remove"></div>
		</div>';
		echo
	'</div>';

	echo '</section>';

	//дополнительно
	if (! empty($result["additional_cost"]))
	{
		echo
		'<section class="table-d__section table-d__additions">
			<div class="table-d__rows table-d__title">
				<div class="table-d__row">
					<h4 class="cell-d cell-d_title">'.$this->diafan->_('Дополнительно').'</h4>
				</div>
			</div>
			<div class="table-d__rows table-d__enum">';
				foreach ($result["additional_cost"] as $row)
				{
					echo
					'<label class="table-d__row table-d__addition" for="additional_cost_'.$row['id'].'">
						<div class="cell-d cell-d_details details-d">
							<div class="detail-d detail-d_name">'.$row["name"].'</div>
							<div class="detail-d detail-d_desc _text">';
								echo $row['text'];
								if ($row['amount'])
								{
									echo '<p>'.$this->diafan->_('Бесплатно от суммы').' '.$row['amount'].' '.$result["currency"].'</p>';
								}
								if ($row['percent'])
								{
									echo '<p>'.$this->diafan->_('Стоимость').' '.$row['percent'].'%</p>';
								}
								echo
							'</div>
						</div>';
						echo
						'<div class="cell-d cell-d_sum">
							<strong class="price-d price-d_fact">
								<span class="price-d__num">'.$row["summ"].'</span>
								<span class="price-d__cur">'.$result["currency"].'</span>
							</strong>
						</div>';
						if ($this->diafan->_site->theme('show_wishlist'))
						{
							echo '<div class="cell-d cell-d_wishlist"></div>';
						}
						echo
						'<div class="cell-d cell-d_select">
							<div class="field-d">
								<input name="additional_cost_ids[]" value="'.$row['id'].'" type="checkbox" id="additional_cost_'.$row['id'].'"'.($row["checked"] ? ' checked' : '').'>
								<label for="additional_cost_'.$row['id'].'"></label>
							</div>
						</div>
					</label>';
				}
				echo
			'</div>
		</section>';
	}

	//способы доставки
	if (! empty($result["delivery"]))
	{
		echo
		'<section class="table-d__section table-d__deliveries">
			<div class="table-d__rows table-d__title">
				<div class="table-d__row">
					<h4 class="cell-d cell-d_title">'.$this->diafan->_('Доставка').'</h4>
				</div>
			</div>
			<div class="table-d__rows table-d__enum">';
				foreach ($result["delivery"] as $row)
				{
					echo
					'<label class="table-d__row table-d__delivery" for="delivery_id_'.$row['id'].'">';
						if (! empty($row["thresholds"]) && empty($result["hide_form"]))
						{
							foreach ($row["thresholds"]  as $r)
							{
								if($r["amount"])
								{
									$row['text'] .= '<br>'.($r["price"] ? $this->diafan->_('Стоимость').' '.$r["price"].' '.$result["currency"].' '.$this->diafan->_('от суммы') : $this->diafan->_('Бесплатно от суммы')).' '.$r['amount'].' '.$result["currency"];
								}
								else
								{
									$row['text'] .= '<br>'.($r["price"] ? $this->diafan->_('Стоимость').' '.$r["price"].' '.$result["currency"] : $this->diafan->_('Бесплатно'));
								}
							}
							if(! empty($row["discount_total"]))
							{
								$row['text'] .= '<br>'.$this->diafan->_('Скидка на сумму заказа').' '.$row["discount_total"]["discount_summ"].' '.$row["discount_total"]["currency"];
							}
						}
						echo
						'<div class="cell-d cell-d_details details-d">
							<div class="detail-d detail-d_name">'.$row["name"].'</div>
							<div class="detail-d detail-d_desc _text">'.$row['text'].'</div>
						</div>';
						echo
						'<div class="cell-d cell-d_sum">
							<strong class="price-d price-d_fact">
								<span class="price-d__num">';
									if (is_null($row["price"]))
									{
										echo $this->diafan->_('Недоступно');
									}
									elseif ($row["price"] !== false)
									{
										echo $row["price"];
									}
									echo
								'</span>';
								if (! is_null($row["price"]) && $row["price"] !== false)
								{
									echo ' <span class="price-d__cur">'.$result["currency"].'</span>';
								}
								echo
							'</strong>
						</div>';
						if ($this->diafan->_site->theme('show_wishlist'))
						{
							echo '<div class="cell-d cell-d_wishlist"></div>';
						}
						echo
						'<div class="cell-d cell-d_select">
							<div class="field-d">
								<input name="delivery_id" id="delivery_id_'.$row['id'].'" value="'.$row['id'].'" type="radio"'.($row["selected"] ? ' checked' : '').' data-service="'.$row["service"].'">
								<label for="delivery_id_'.$row['id'].'"></label>
							</div>
						</div>';
						echo 
					'</label>';
					if ($row["service_view"])
					{
						echo '<div class="table-d__row table-d__widget">';
						echo $row["service_view"];
						echo '</div>';
					}
				}
				echo
			'</div>
		</section>';
	}
}

echo
'<section class="table-d__section table-d__fulltotal">
	<div class="table-d__rows table-d__total table-d__total_cart">';
		echo
		'<div class="table-d__row">
			<div class="cell-d cell-d_details cell-d_title">'.$this->diafan->_('Итого').':</div>
			<div class="cell-d cell-d_total">
				<strong class="price-d">
					<span class="price-d__num">'.$result["summ"].'</span>
					<span class="price-d__cur">'.$result["currency"].'</span>
				</strong>';
				if (! empty($result["tax"]))
				{
					echo '
					<span class="price-d price-d_tax">
						<span class="price-d__name">'.$this->diafan->_('в т. ч. %s', true, $result["tax_name"]).'</span>
						<span class="price-d__num">'.$result["tax"].'</span>
						<span class="price-d__cur">'.$result["currency"].'</span>
					</span>';
				}
				echo
			'</div>
		</div>';
		echo
	'</div>
</section>';

echo '</div>';

if ($this->diafan->_site->theme('show_sharecart') && ! empty($result["share_link"]))
{
	echo
	'<div class="sharecart-d">
		<input type="text" placeholder="'.$this->diafan->_('Введите e-mail', false).'" value="" id="js_share_link_email_input" style="display:none">
		<div class="errors error-share" id="js_share_link_error" style="display:none"></div>
		<a href="'.BASE_PATH_HREF.$result["share_link"].'" class="button-d button-d_outline button-d_multiline" id="js_cart_share_email" data-send="'.$this->diafan->_('Отправить', false).'">
			<span class="button-d__icon icon-d fas fa-envelope"></span>
			<span class="button-d__name">'.$this->diafan->_('Отправить товары из корзины на E-mail').'</span>
		</a>
		<a href="'.BASE_PATH_HREF.$result["share_link"].'" class="button-d button-d_outline button-d_multiline" id="js_cart_share_copy" data-result="'.$this->diafan->_('Скопировано', false).'">
			<span class="button-d__icon icon-d fas fa-copy"></span>
			<span class="button-d__name">'.$this->diafan->_('Скопировать ссылку на корзину').'</span>
		</a>
	</div>';
}
