<?php
/**
 * Обработка данных, полученных от T-Bank
 *
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2021 OOO «Диафан» (http://www.diafan.ru/)
 */

if (! defined('DIAFAN'))
{
	$path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}

require_once ('payment.tbank.model.php');

$payment_model = new Payment_tbank_model($this->diafan);
$payment = $payment_model->getPaymentByElementId($_REQUEST['OrderId']);

switch ($_GET["rewrite"]) {
    case 'tbank/notification':
        if (!$payment) {
            die('NOTOK');
        }

        if ($payment_model->getToken($_POST, unserialize($payment['params'])['tbank_password']) != $_POST['Token']) {
            die('NOTOK');
        }

        if ('CONFIRMED' == $_POST['Status']) {
            $this->diafan->_payment->success($payment, 'pay');
        }

        die('OK');

        break;

    case 'tbank/success':
        if (!$payment) {
            Custom::inc('includes/404.php');
        }

        $this->diafan->_payment->success($payment, 'redirect');
        break;

    case 'tbank/failure':
        if (!$payment) {
            Custom::inc('includes/404.php');
        }

        $this->diafan->_payment->fail($payment);
        break;

    default:
        Custom::inc('includes/404.php');
        break;
}
