<?php
/**
 * Настройки SMS-провайдера «smsc.ru»
 * 
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2019 OOO «Диафан» (http://www.diafan.ru/)
 */

if (! defined('DIAFAN'))
{
	$path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}

class Postman_smsc_admin extends Diafan
{
	public $config = array(
		'name' => 'SMSC.ru',
		'params' => array(
			'help' => array(
				'type' => 'info',
				'name' => 'Для подключения SMS-уведомлений требуется <a href="https://smsc.ru/?pp523455" target="_blank">регистрация</a>.',
				'help' => 'SMS-рассылки интегрирована в модули «Обратная связь», «Оформление заказа», «Комментарии», «Вопрос-Ответ» для уведомления администраторов. А также в модуль «Рассылки» для массовой рассылки SMS. Подключить SMS-уведомления нужно в настройках соответствующего модуля. Для включения SMS на сайте необходимо зарегистрироваться в системе [smsc.ru](https://smsc.ru/?pp523455).',
			),
			'login' => array(
				'type' => 'text',
				'name' => 'Логин',
				'help' => 'Ваш логин в smsc.ru',
			),
			'psw' => array(
				'type' => 'text',
				'name' => 'Пароль API (<a href="https://smsc.ru/passwords/?pp523455" target="_blank">создать API-пароль в smsc.ru</a>)',
				'help' => 'API-пароль аккаунта .',
			),
			'signature' => array(
				'type' => 'text',
				'name' => 'Подпись-имя отправителя (<a href="http://smsc.ru/senders/?pp523455" target="_blank">узнать/добавить имя отправителя</a>)',
				'help' => 'Подпись отправителя SMS (данные из настроек сервиса smsc.ru). Иначе смс будет отправлена от случайного номера, доставка не гарантируется!',
			),
		),
	);
}
