/**
 * JS-сценарий модуля
 *
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2021 OOO «Диафан» (http://www.diafan.ru/)
 */


$(function () {

	var $win = $(window),
		$bod = $('body'),
		$doc = $(document);
	
	$doc.on('click', '.js_shop_setting_view', function (e) {
		e.preventDefault();
		
		var $setting = $(this);
	
		var view = $setting.data('view');
		if (!view) return;
	
		var del_view = '';
		var add_view = '';
	
		switch (view)
		{
			case 'rows':
				del_view = '_viewgrid';
				add_view = '_viewrows';
				setcookie_view('rows');
				break;
			case 'grid':
			default:
				del_view = '_viewrows';
				add_view = '_viewgrid';
				setcookie_view('grid');
				break;
		}
	
		$('.section-d__list.' + del_view).removeClass(del_view).addClass(add_view);
	
		$('.js_shop_setting_view._active').removeClass('_active');
		$('.js_shop_setting_view[data-view=' + view).addClass('_active');
	});
	function setcookie_view(view)
	{
		document.cookie = '_diafan_shop_view=' + encodeURIComponent(view) + '; path=/; max-age=7200';
	}
	function getcookie_view()
	{
		var view = document.cookie.match(new RegExp("(?:^|; )_diafan_shop_view=([^;]*)"));
		return view ? decodeURIComponent(view[1]) : undefined;
	}
	function delcookie_view() {
		document.cookie = '_diafan_shop_view=; path=/; max-age=0';
	}

	$doc.on('change', '.js_shop_setting_sort', function (e) {
		var $select = $(this);
		if ($select.val()) window.location.href = $select.val();
	});

	$doc.on('click', '.js_shop_setting_filter_show', function (e) {
		$bod.toggleClass('_shop-filter-show');

		var $button = $(this);
		var name = $bod.hasClass('_shop-filter-show') ? $button.data('name1') : $button.data('name2');
        if (name) $button.find('.button-d__name').first().text(name);
	});

	// if (window.matchMedia('(max-width: 921px)').matches)
	// {
	// 	$doc.on('click', function (e) {
	// 		if ($(e.target).closest('.setting-d').length) {
	// 			return true;
	// 		}
	// 		$bod.removeClass('_shop-filter-show');
	// 	});
	// }
});
