<?php
/**
 * Шаблон первой страницы модуля, если в настройках модуля подключен параметр «Использовать категории»
 *
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2021 OOO «Диафан» (http://www.diafan.ru/)
 */

if (! defined('DIAFAN'))
{
    $path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}



if (empty($result["categories"])) return false;

echo '<section class="section-d section-d_home section-d_shop section-d_shop_home">';

//начало большого цикла, вывод категорий и товаров в них
foreach ($result["categories"] as $cat_id => $cat)
{
	echo '<div class="category-d category-d_main category-d_row">';
	if (! empty($cat["img"]))
	{
		echo '<div class="category-d__images">';
		foreach ($cat["img"] as $img)
		{
			switch ($img["type"])
			{
				case 'animation':
					echo '<a class="_fit" href="'.BASE_PATH.$img["link"].'" data-fancybox="gallery'.$cat_id.'shop_cat">';
					break;
				case 'large_image':
					echo '<a class="_fit" href="'.BASE_PATH.$img["link"].'" rel="large_image" width="'.$img["link_width"].'" height="'.$img["link_height"].'">';
					break;
				default:
					echo '<a class="_fit" href="'.BASE_PATH_HREF.$img["link"].'">';
					break;
			}
			if ($img["source"])
			{
				echo $img["source"];
			}
			else
			{
				echo '<img src="'.$img["src"].'" width="'.$img["width"].'" height="'.$img["height"].'" alt="'.$img["alt"].'" title="'.$img["title"].'">';
			}
			echo '</a>';
		}
		echo '</div>';
	}
	echo '<div class="category-d__details details-d">';
	echo '<div class="category-d__name"><a href="'.BASE_PATH_HREF.$cat["link_all"].'">'.$cat["name"].'</a></div>';
	if (! empty($cat["anons"]))
	{
		echo '<div class="category-d__text _text">'.$cat['anons'].'</div>';
	}
	echo '</div>';
	echo '</div>';

	//вывод подкатегорий
	if (! empty($cat["children"]))
	{
		echo '<div class="section-d__children">';
		foreach ($cat["children"] as $child)
		{
			echo '<a class="category-d category-d_child category-d_rowcard" href="'.BASE_PATH_HREF.$child["link"].'">';
			if (! empty($child["img"]))
			{
				echo '<div class="category-d__images">';
				foreach ($child["img"] as $img)
				{
					echo '<figure class="_fit">';
					if ($img["source"])
					{
						echo $img["source"];
					}
					else
					{
						echo '<img src="'.$img["src"].'" width="'.$img["width"].'" height="'.$img["height"].'" alt="'.$img["alt"].'" title="'.$img["title"].'">';
					}
					echo '</figure>';
					break;
				}
				echo '</div>';
			}
			echo '<div class="category-d__details details-d">';
			echo '<div class="category-d__name">'.$child["name"].'</div>';
			if (! empty($child["anons"]))
			{
				echo '<div class="category-d__text _text">'.$child['anons'].'</div>';
			}
			echo '</div>';
			echo '</a>';

			//вывод списка товаров подкатегории
			if (! empty($child["rows"]))
			{
				$res = $result; unset($res["show_more"]);
				$res["rows"] = $child["rows"];

				echo '<div class="section-d__list _viewgrid">';
				echo $this->get('rows', 'shop', $res);
				echo '</div>';
			}
		}
		echo '</div>';
	}

	//вывод списка товаров категории
	if (! empty($cat["rows"]))
	{
		$res = $result; unset($res["show_more"]);
		$res["rows"] = $cat["rows"];

		echo '<div class="section-d__list _viewgrid">';
		echo $this->get('rows', 'shop', $res);
		echo '</div>';
	}
}

//Кнопка "Показать ещё"
if (! empty($result["show_more"]))
{
	echo $result["show_more"];
}

//постраничная навигация
if (! empty($result["paginator"]))
{
	echo $result["paginator"];
}

echo '</section>';
