<?php
/**
 * Шаблон списка товаров
 *
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2021 OOO «Диафан» (http://www.diafan.ru/)
 */

if (! defined('DIAFAN'))
{
    $path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if ($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}



if (! empty($result["error"]))
{
	echo '<p class="_note">'.$result["error"].'</p>';
	return;
}

if (empty($result["ajax"]))
{
	echo '<section class="section-d section-d_list section-d_shop section-d_shop_cat shop_list js_shop_list">';
}

//вывод подкатегорий
if (! empty($result["children"]))
{
	echo '<div class="section-d__children">';
	foreach ($result["children"] as $child)
	{
		echo '<a class="category-d category-d_child category-d_rowcard" href="'.BASE_PATH_HREF.$child["link"].'">';
		if (! empty($child["img"]))
		{
			echo '<div class="category-d__images">';
			foreach ($child["img"] as $img)
			{
				echo '<figure class="_fit">';
				if ($img["source"])
				{
					echo $img["source"];
				}
				else
				{
					echo '<img src="'.$img["src"].'" width="'.$img["width"].'" height="'.$img["height"].'" alt="'.$img["alt"].'" title="'.$img["title"].'">';
				}
				echo '</figure>';
				break;
			}
			echo '</div>';
		}
		echo '<div class="category-d__details details-d">';
		echo '<div class="category-d__name">'.$child["name"].'</div>';
		if ($child["anons"])
		{
			echo '<div class="category-d__text _text">'.$child['anons'].'</div>';
		}
		echo '</div>';
		echo '</a>';

		//вывод списка товаров подкатегории
		if (! empty($child["rows"]))
		{
			$res = $result; unset($res["show_more"]);
			$res["rows"] = $child["rows"];

			$view = '_viewgrid';
			if (! empty($_COOKIE['_diafan_shop_view']))
			{
				switch ($_COOKIE['_diafan_shop_view'])
				{
					case 'rows':
						$view = '_viewrows';
						break;
				}
			}
			echo '<div class="section-d__list '.$view.'">';
			echo $this->get($result["view_rows"], 'shop', $res);
			echo '</div>';
		}
	}
	echo '</div>';
}

//вывод списка товаров текущей категории
if (! empty($result["rows"]))
{
	//вывод сортировки товаров текущей категории
	if (! empty($result["link_sort"]))
	{
		echo $this->get('sort_block', 'shop', $result);
	}

	$view = '_viewgrid';
	if (! empty($_COOKIE['_diafan_shop_view']))
	{
		switch ($_COOKIE['_diafan_shop_view'])
		{
			case 'rows':
				$view = '_viewrows';
				break;
		}
	}
	echo '<div class="section-d__list '.$view.'">';
	echo $this->get($result["view_rows"], 'shop', $result);
	echo '</div>';
}

//постраничная навигация
if (! empty($result["paginator"]))
{
	echo $result["paginator"];
}

echo '<article class="category-d category-d_main category-d_row">';
/* if (! empty($result["img"]))
{
	echo '<div class="category-d__images">';
	foreach ($result["img"] as $img)
	{
		switch ($img["type"])
		{
			case 'animation':
				echo '<a class="_fit" href="'.BASE_PATH.$img["link"].'" data-fancybox="gallery'.$result["id"].'shop_cat">';
				break;
			case 'large_image':
				echo '<a class="_fit" href="'.BASE_PATH.$img["link"].'" rel="large_image" width="'.$img["link_width"].'" height="'.$img["link_height"].'">';
				break;
			default:
				echo '<a class="_fit" href="'.BASE_PATH_HREF.$img["link"].'">';
				break;
		}
		if ($img["source"])
		{
			echo $img["source"];
		}
		else
		{
			echo '<img src="'.$img["src"].'" width="'.$img["width"].'" height="'.$img["height"].'" alt="'.$img["alt"].'" title="'.$img["title"].'">';
		}
		echo '</a> ';
	}
	echo '</div>';
} */
echo '<div class="category-d__details details-d">';
if (! empty($result['text']))
{
	echo '<div class="category-d__text _text">'.$this->htmleditor($result['text']).'</div>';
}
echo '</div>';
echo '</article>';

//вывод ссылок на предыдущую и последующую категории
echo $this->htmleditor('<insert name="show_previous_next" module="shop">');

//вывод комментариев ко всей категории товаров (комментарии к конкретному товару в функции id())
if (! empty($result["comments"]))
{
	echo $result["comments"];
}

if (empty($result["ajax"]))
{
	echo '</section>';
}
