<?php
/**
 * Шаблон блока «Сортировать» с ссылками на направление сортировки
 * 
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2021 OOO «Диафан» (http://www.diafan.ru/)
 */

if (! defined('DIAFAN'))
{
    $path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}



$link_sort   = $result["link_sort"];
$sort_config = $result['sort_config'];

echo
'<div class="settings-d">';

	echo 
	'<div class="setting-d setting-d_sort">
		<select class="setting-d__select js_shop_setting_sort">
			<option value="'.BASE_PATH_HREF.$this->diafan->_route->current_link(array('page', 'sort')).'">'.$this->diafan->_('По умолчанию', false).'</option>';
			foreach ($sort_config['sort_fields_names'] as $key => $name)
			{
				$asc  = isset($link_sort[$key])     ? $link_sort[$key]     : '';
				$desc = isset($link_sort[$key + 1]) ? $link_sort[$key + 1] : '';
				switch ($key)
				{
					case 1:
						$name_asc  = $this->diafan->_('Сначала дешевле', false);
						$name_desc = $this->diafan->_('Сначала дороже', false);
						break;
					case 3:
						$name_asc  = $this->diafan->_('Сначала А-Я', false);
						$name_desc = $this->diafan->_('Сначала Я-А', false);
						break;
					default:
						$name_asc  = $name.': '.$this->diafan->_('по возрастанию', false);
						$name_desc = $name.': '.$this->diafan->_('по убыванию', false);
				}
				echo '
				<option'.($asc ? ' value="'.BASE_PATH_HREF.$asc.'"' : ' selected').'>'.$name_asc.'</option>
				<option'.($desc ? ' value="'.BASE_PATH_HREF.$desc.'"' : ' selected').'>'.$name_desc.'</option>';
			}
			echo '
		</select>
	</div>';

	$view = 'grid';
	if (! empty($_COOKIE['_diafan_shop_view']))
	{
		switch ($_COOKIE['_diafan_shop_view'])
		{
			case 'rows':
				$view = 'rows';
			break;
		}
	}

	echo 
	'<div class="setting-d setting-d_views">
		<ul class="setting-d__list">
			<li class="setting-d__item">
				<span class="setting-d__views">';
					echo
					'<a class="setting-d__view setting-d__view_grid'.($view == 'grid' ? ' _active' : '').' js_shop_setting_view" title="'.$this->diafan->_('Сетка', false).'" data-view="grid">
						<span class="setting-d__icon icon-d fas fa-th"></span>
					</a>';
					echo
					'<a class="setting-d__view setting-d__view_rows'.($view == 'rows' ? ' _active' : '').' js_shop_setting_view" title="'.$this->diafan->_('Ряд', false).'" data-view="rows">
						<span class="setting-d__icon icon-d fas fa-th-list"></span>
					</a>';
					echo
				'</span>
			</li>
		</ul>
	</div>';

	if ($this->diafan->_site->theme('show_filter') && $this->diafan->_route->cat)
	{
		echo 
		'<div class="setting-d setting-d_filter-show">
			<button class="button-d button-d_outline js_shop_setting_filter_show" type="button" data-name1="'.$this->diafan->_('Скрыть', false).'" data-name2="'.$this->diafan->_('Фильтр', false).'">
				<span class="button-d__icon icon-d fas fa-filter"></span>
				<span class="button-d__name">'.$this->diafan->_('Фильтр').'</span>
			</button>
		</div>
		<div class="setting-d setting-d_filter setting-d_fill">';
		//шаблонный тег вывода формы поиска по товарам. Вид формы редактируется в файле modules/shop/views/shop.view.show_search.php
		echo $this->htmleditor('<insert name="show_search" module="shop" only_module="true" cat_id="current" ajax="true">');
		echo '</div>';
	}

	echo
'</div>';
