/**
 * JS-сценарий
 *
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2023 OOO «Диафан» (http://www.diafan.ru/)
 */



$(function () {

    $('.tutorial-tab').on('click', function (e) {
        e.preventDefault();
        var $tab = $(this);
        var $tutorial = $tab.closest('.tutorial').toggleClass('tutorial_active');
        var isActive = $tutorial.hasClass('tutorial_active');
        var title = isActive ? $tab.data('titleHide') : $tab.data('titleShow');
        if (title) $tab.attr('title', title);
        var name = isActive ? $tab.data('nameHide') : $tab.data('nameShow');
        if (name) $tab.children('.tutorial-tab__name').first().text(name);
    });

    function normColor(color)
    {
        color = color.replace(/[^A-F0-9#]+/gi, '');
        var n = color.length;
        if (n)
        {
            if (color[0] != '#') color = '#' + color;
            if (n > 7) color = color.slice(0, 7);
        }
        return color;
    }
    function isColor(color) {
        var regexp = /^#([A-F0-9]{3}|[A-F0-9]{6})$/i;
        return regexp.test(color);
    }

    $('.colorpicker-preview__input').on('input change', function (e) {
        var $input = $(this);
        var $cp = $input.closest('.colorpicker');
        var color = normColor($input.val());
        $cp.toggleClass('colorpicker_blank', !isColor(color));
        $cp.find('.colorpicker__preview').css('background', color);
        $cp.find('.colorpicker__input').val(color);
        $input.val(color);
    });
    $('.colorpicker__input').on('input change', function (e) {
        var $input = $(this);
        var $cp = $input.closest('.colorpicker');
        var color = normColor($input.val());
        $cp.toggleClass('colorpicker_blank', !isColor(color));
        $cp.find('.colorpicker-preview__input').val(color);
        $cp.find('.colorpicker__preview').css('background', color);
        $input.val(color);
    });
    // $('.colorpicker__alpha-range').on('input change', function () {
    //     var $input = $(this);
    //     var alpha = $input.val();
    //     var $cp = $input.closest('.colorpicker');
    //     $cp.find('.colorpicker__alpha').val(alpha);
    // });
    $('.colorpicker__reset').on('click', function (e) {
        var $button = $(this);
        var $cp = $button.closest('.colorpicker');
        var color = normColor($cp.data('color'));
        // var alpha = normAlpha($cp.data('alpha'));
        $cp.toggleClass('colorpicker_blank', !isColor(color));
        $cp.find('.colorpicker-preview__input').val(color);
        $cp.find('.colorpicker__input').val(color);
        $cp.find('.colorpicker__preview').css('background', color);
        // $cp.find('.colorpicker__alpha').val(alpha);
    });



    $('.item-list').on('click', '.item-list__action', function (e) {
        var $action = $(this);

        var $list = $action.closest('.item-list');
        var $items = $list.children('.item-list__items');

        var action = $action.data('action');
        switch (action)
        {
            case 'add':
                $items.append($items.children().last().clone());
                break;
        }
    });
    $('.item-list').on('click', '.list-item__action', function (e) {
        var $action = $(this);

        var $item = $action.closest('.list-item');
        if ($item.length)
        {
            var action = $action.data('action');
            switch (action)
            {
                case 'up':
                    var $prev = $item.prev();
                    if ($prev.length) $prev.before($item);
                    break;
                case 'down':
                    var $next = $item.next();
                    if ($next.length) $next.after($item);
                    break;
                case 'delete':
                    $action.closest('.list-item').remove();
                    break;
            }
        }
    });

    $('.picture__delete').on('click', function (e) {
        var $del = $(this);

        var $pic = $del.closest('.picture');
        if ($pic.length)
        {
            $pic.find('input[type=hidden]').val(1);
            $pic.find('img').remove();
            $del.remove();
        }
    });
});
