<?php
/**
 * Настройки шаблона сайта
 *
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2020 OOO «Диафан» (http://www.diafan.ru/)
 */

if (! defined('DIAFAN'))
{
	$path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}

/**
 * Site_admin_theme_custom
 */
class Site_admin_theme_custom extends Diafan
{
	/**
	 * @var array поля для редактирования
	 */
	public $variables = array (
		'base' => array(
			'logo' => array(
				'type' => 'image',
				'name' => 'Логотип',
				'multilang' => true,
			),
			'logo_name' => array(
				'type' => 'textarea',
				'name' => 'Название сайта',
				'multilang' => true,
			),
			'logo_text' => array(
				'type' => 'textarea',
				'name' => 'Слоган',
				'multilang' => true,
			),
			'favicon' => array(
				'type' => 'favicon',
				'name' => 'Favicon',
			),
			'color' => array(
				'type' => 'color',
				'name' => 'Основной цвет',
				'default' => '#c53c12',
				'files' => 'css/colors.css',
				'tutorial' => 'Эта настройка изменит основной цвет сайта.',
			),
			'phone' => array(
				'type' => 'phone',
				'name' => 'Телефон',
				'help' => "Контактный телефон.",
				'multilang' => true,
			),
			'phone2' => array(
				'type' => 'textarea',
				'name' => 'Телефон дополнительный',
				'help' => "Контактный телефон/ы.",
				'multilang' => true,
			),
			'email' => array(
				"type" => "email",
				"name" => 'E-mail',
				'multilang' => true,
			),
			'email2' => array(
				'type' => 'textarea',
				'name' => 'E-mail дополнительный',
				'help' => "Контактный адрес/а электронной почты.",
				'multilang' => true,
			),
			'contacts' => array(
				'type' => 'editor',
				'name' => 'Контакты',
				'help' => "Адрес организации.",
				'multilang' => true,
			),
			'copyright' => array(
				'type' => 'textarea',
				'name' => 'Копирайт',
				'multilang' => true,
			),
			'document_head' => array(
				'type' => 'textarea',
				'name' => 'JS-коды счётчиков в head',
				'help' => 'Коды счётчиков Яндекс, Google и т.п.',
				'multilang' => true,
			),
			'document_body' => array(
				'type' => 'textarea',
				'name' => 'JS-коды счётчиков в body',
				'help' => 'Коды счётчиков Яндекс, Google и т.п.',
				'multilang' => true,
			),
		),
		'header' => array(
			'show_menu_top' => array(
				'type' => 'checkbox',
				'name' => 'Показывать меню в верхней части страницы',
			),
			'show_langs' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Языки сайта»',
			),
			'show_search' => array(
				'type' => 'checkbox',
				'name' => 'Показывать поиск по сайту',
			),
			// 'show_feedback' => array(
			// 	'type' => 'checkbox',
			// 	'name' => 'Показывать блок «Обратная связь»',
			// ),
			'show_lk' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Личный кабинет»',
			),
			'show_compare' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Сравнение»',
			),
			'show_wishlist' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Избранное»',
			),
			'show_cart' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Корзина»',
			),
		),
		'home' => array(
			'show_slider' => array(
				'type' => 'checkbox',
				'name' => 'Показывать слайдер',
			),
			'show_catalog' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Товары»',
			),
			'show_new' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Новинки»',
			),
			'show_hit' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Хиты»',
			),
			'show_action' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Акции»',
			),
			'show_content' => array(
				'type' => 'checkbox',
				'name' => 'Показывать содержимое страницы',
			),
			'show_banners' => array(
				'type' => 'checkbox',
				'name' => 'Показывать баннеры «Спецпредложение»',
			),
			'show_clauses' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Статьи»',
			),
			'show_comments' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Комментарии»',
			),
			'show_faq' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Вопрос-ответ»',
			),
			'show_subscription' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Подписаться на рассылку»',
			),
		),
		'aside' => array(
			'show_filter' => array(
				'type' => 'checkbox',
				'name' => 'Показывать фильтр по товарам',
			),
			'show_news' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Новости»',
			),
			'show_photos' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Фотографии»',
			),
		),
		'good' => array(
			'show_share' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Поделиться»',
			),
			'show_good_set' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Наборы»',
			),
			'show_good_rel' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Похожие товары»',
			),
			'show_good_order_rel' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «С этим товаром покупают»',
			),
			'delivery' => array(
				'type' => 'editor',
				'name' => 'Блок о доставке в карточке товара',
				'multilang' => true
			),
		),
		'cart' => array(
			'show_recomm' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Рекомендуем»',
			),
			'show_coupon' => array(
				'type' => 'checkbox',
				'name' => 'Показывать форму ввода купона',
			),
			'show_sharecart' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Поделиться корзиной»',
			),
		),
		'footer' => array(
			'show_menu_bottom' => array(
				'type' => 'checkbox',
				'name' => 'Показывать меню в нижней части страницы',
			),
			'show_menu_footer' => array(
				'type' => 'checkbox',
				'name' => 'Показывать меню в подвале страницы',
			),
			'show_diafan' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «DIAFAN.CMS»',
			),
			'show_sitemap' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Карта сайта»',
			),
			'show_privacy' => array(
				'type' => 'checkbox',
				'name' => 'Показывать блок «Политика конфиденциальности»',
			),
			'show_upper' => array(
				'type' => 'checkbox',
				'name' => 'Показывать кнопку «Вверх»',
			),
			'show_consultant' => array(
				'type' => 'checkbox',
				'name' => 'Показывать онлайн-консультант',
			),
			'show_payments' => array(
				'type' => 'enum',
				'name' => 'Показывать блок «Способы оплаты»',
				'select' => array(
					'visa' => 'VISA',
					'mastercard' => 'MasterCard',
					'maestro' => 'Maestro',
					'jcb' => 'JCB',
					'mir' => 'МИР',
					'paypal' => 'PayPal',
					'unionpay' => 'UnionPay',
					'webmoney' => 'WebMoney',
				),
				'multilang' => true,
			),
			'show_socnets' => array(
				'type' => 'enum',
				'name' => 'Показывать блок «Социальные сети»',
				'select' => array(
					'vk' => 'VK',
					'ok' => 'Одноклассники',
					'dzen' => 'Дзен',
					'rutube' => 'RUTUBE',
					'youtube' => 'YouTube',
					'telegram' => 'Telegram',
					'whatsapp' => 'WhatsApp',
					'viber' => 'Viber',
					'instagram' => 'Instagram',
					'facebook' => 'Facebook',
					'x' => 'X (Twitter)',
				),
				'multilang' => true,
			),
			'socnet_vk' => array(
				'type' => 'text',
				'name' => 'VK',
				'multilang' => true,
				'depend' => 'theme_show_socnets[]=vk',
			),
			'socnet_ok' => array(
				'type' => 'text',
				'name' => 'Одноклассники',
				'multilang' => true,
				'depend' => 'theme_show_socnets[]=ok',
			),
			'socnet_dzen' => array(
				'type' => 'text',
				'name' => 'Дзен',
				'multilang' => true,
				'depend' => 'theme_show_socnets[]=dzen',
			),
			'socnet_rutube' => array(
				'type' => 'text',
				'name' => 'RUTUBE',
				'multilang' => true,
				'depend' => 'theme_show_socnets[]=rutube',
			),
			'socnet_youtube' => array(
				'type' => 'text',
				'name' => 'YouTube',
				'multilang' => true,
				'depend' => 'theme_show_socnets[]=youtube',
			),
			'socnet_telegram' => array(
				'type' => 'text',
				'name' => 'Telegram',
				'multilang' => true,
				'depend' => 'theme_show_socnets[]=telegram',
			),
			'socnet_whatsapp' => array(
				'type' => 'text',
				'name' => 'WhatsApp',
				'multilang' => true,
				'depend' => 'theme_show_socnets[]=whatsapp',
			),
			'socnet_viber' => array(
				'type' => 'text',
				'name' => 'Viber',
				'multilang' => true,
				'depend' => 'theme_show_socnets[]=viber',
			),
			'socnet_instagram' => array(
				'type' => 'text',
				'name' => 'Instagram',
				'multilang' => true,
				'depend' => 'theme_show_socnets[]=instagram',
			),
			'socnet_facebook' => array(
				'type' => 'text',
				'name' => 'Facebook',
				'multilang' => true,
				'depend' => 'theme_show_socnets[]=facebook',
			),
			'socnet_x' => array(
				'type' => 'text',
				'name' => 'X (Twitter)',
				'multilang' => true,
				'depend' => 'theme_show_socnets[]=x',
			),
		),
	);

	/**
	 * @var array названия табов
	 */
	public $tabs_name = array(
		'base' => 'Основные настройки',
		'header' => 'Шапка',
		'home' => 'Главная',
		'aside' => 'Колонка',
		'good' => 'Товар',
		'cart' => 'Корзина',
		'footer' => 'Подвал',
	);

	/**
	 * Подготавливает конфигурацию
	 *
	 * @return void
	 */
	public function prepare_config()
	{
		foreach ($this->variables as $title => $variable_table)
		{
			foreach ($variable_table as $key => $row)
			{
				if ($row['type'] == 'color' && ! empty($row['tutorial']) && in_array('csseditor', $this->diafan->installed_modules))
				{
					$this->variables[$title][$key]['tutorial'] .= '<br> Для тонкой настройки цветовой гаммы, воспользуйтесь <a href="'.BASE_PATH_HREF.'csseditor/">модулем «Цветовое оформление»</a>';
				}
			}
		}
	}
}
