<?php
/**
 * Обработка POST-запросов в административной части модуля
 *
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2023 OOO «Диафан» (http://www.diafan.ru/)
 */
if ( ! defined('DIAFAN'))
{
	$path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}

/**
 * Users_admin_action
 */
class Users_admin_action extends Action_admin
{
	/**
	 * Вызывает обработку POST-запросов
	 *
	 * @return void
	 */
	public function init()
	{
		if ($name = preg_replace('/[^a-z0-9_]+/', '', $this->diafan->filter($_POST, 'string', 'widget')))
		{
			$class_name = 'Users_admin_widget_'.$name.'_action';
			$class_path = 'modules/users/admin/widget/'.$name.'/users.admin.widget.'.$name.'.action.php';
			if (Custom::exists($class_path))
			{
				Custom::inc($class_path);
				$action = new $class_name($this->diafan);
				$action->init();
				$this->result = $action->result;
			}
		}
	}
}
