<?php
/**
 * История действий пользователей
 * 
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2023 OOO «Диафан» (http://www.diafan.ru/)
 */

if (! defined('DIAFAN'))
{
	$path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}

/**
 * Users_admin_history
 */
class Users_admin_history extends Frame_admin
{
	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'users_history';

	/**
	 * @var array поля в списка элементов
	 */
	public $variables_list = array (
		'created' => array(
			'name' => 'Дата и время',
			'type' => 'datetime',
			'sql' => true,
			'no_important' => true,
		),
		'user_id' => array(
			'type' => 'function',
			'name' => 'Пользователь',
			'sql' => true,
		),
		'module_name' => array(
			'type' => 'function',
			'name' => 'Модуль',
			'sql' => true,
		),
		'element_type' => array(
			'type' => 'function',
			'name' => 'Тип элемента',
			'sql' => true,
			'select' => array(
				'element' => array(
					'id' => 'element',
					'name' => 'элемент',
					'color' => '',
					'modules' => array(
						'site' => array(
							'name' => 'страница',
						),
						'bs' => array(
							'name' => 'баннер',
						),
						'news' => array(
							'name' => 'новость',
						),
						'clauses' => array(
							'name' => 'статья',
						),
						'photo' => array(
							'name' => 'фотография',
						),
						'shop' => array(
							'name' => 'товар',
						),
						'order' => array(
							'name' => 'заказ',
						),
						'payment' => array(
							'name' => 'способ оплаты',
						),
						'delivery' => array(
							'name' => 'способ доставки',
						),
						'feedback' => array(
							'name' => 'сообщение',
						),
						'users' => array(
							'name' => 'пользователь',
						),
						'custom' => array(
							'name' => 'тема',
						),
						'service' => array(
							'name' => 'модуль',
						),
						'addons' => array(
							'name' => 'дополнение',
						),
						'update' => array(
							'name' => 'обновление',
						),
					),
				),
				'cat' => array(
					'id' => 'cat',
					'name' => 'категория',
					'color' => '',
					'modules' => array(
						'photo' => array(
							'name' => 'альбом',
						),
					),
				),
				'param' => array(
					'id' => 'param',
					'name' => 'поле',
					'color' => '',
					'modules' => array(
						'shop' => array(
							'name' => 'характеристика',
						),
					),
				),
				'brand' => array(
					'id' => 'brand',
					'name' => 'производитель',
					'color' => '',
				),
				'config' => array(
					'id' => 'config',
					'name' => 'настройки',
					'color' => '',
				),
				'theme' => array(
					'id' => 'theme',
					'name' => 'настройки шаблона',
					'color' => '',
				),
				'blocks' => array(
					'id' => 'blocks',
					'name' => 'блок',
					'color' => '',
				),
				'order_status' => array(
					'id' => 'order_status',
					'name' => 'статус',
					'color' => '',
				),
				'history' => array(
					'id' => 'history',
					'name' => 'история',
					'color' => '',
				),
				'additional_cost' => array(
					'id' => 'additional_cost',
					'name' => 'сопутствующая услуга',
					'color' => '',
				),
				'return' => array(
					'id' => 'return',
					'name' => 'обновление',
					'color' => '',
				),
				'role' => array(
					'id' => 'role',
					'name' => 'роль',
					'color' => '',
				),
				'notice' => array(
					'id' => 'notice',
					'name' => 'Заметка',
					'color' => '',
				),
				// 'currency' => 'валюта',
				// 'backend' => 'расширение',
				// 'wishlist' => 'избранное',
				// 'waitlist' => 'ожидание',
				// 'dynamic' => 'динамический блок',
			),
		),
		'element_id' => array(
			'type' => 'numtext',
			'name' => 'Номер элемента',
			'sql' => true,
			'no_important' => true,
		),
		'action_name' => array(
			'type' => 'function',
			'name' => 'Действие',
			'sql' => true,
			'select' => array(
				'show' => array(
					'id' => 'show',
					'name' => 'просмотр',
					'color' => '',
				),
				'create' => array(
					'id' => 'create',
					'name' => 'создание',
					'color' => '',
				),
				'edit' => array(
					'id' => 'edit',
					'name' => 'редактирование',
					'color' => '',
				),
				'act' => array(
					'id' => 'act',
					'name' => 'активация',
					'color' => '',
				),
				'deact' => array(
					'id' => 'deact',
					'name' => 'деактивация',
					'color' => '',
				),
				'trash' => array(
					'id' => 'trash',
					'name' => 'в корзину',
					'color' => '',
				),
				'restore' => array(
					'id' => 'restore',
					'name' => 'восстановление из корзины',
					'color' => '',
				),
				'del' => array(
					'id' => 'del',
					'name' => 'удаление',
					'color' => '',
				),
				'clear' => array(
					'id' => 'clear',
					'name' => 'очистка',
					'color' => '',
				),
				'status' => array(
					'id' => 'status',
					'name' => 'статус',
					'color' => '',
				),
				'install' => array(
					'id' => 'install',
					'name' => 'инсталляция',
					'color' => '',
				),
				'uninstall' => array(
					'id' => 'uninstall',
					'name' => 'деинсталляция',
					'color' => '',
				),
				'update' => array(
					'id' => 'update',
					'name' => 'обновление',
					'color' => '',
				),
				'repair' => array(
					'id' => 'repair',
					'name' => 'восстановление БД',
					'color' => '',
				),
				'login' => array(
					'id' => 'login',
					'name' => 'вход',
					'color' => '',
				),
				'logout' => array(
					'id' => 'logout',
					'name' => 'выход',
					'color' => '',
				),
				'subscription' => array(
					'id' => 'subscription',
					'name' => 'Подписка на дополнение',
					'color' => '',
				),
				'unsubscription' => array(
					'id' => 'unsubscription',
					'name' => 'Отмена подписки на дополнение',
					'color' => '',
				),
				'buy' => array(
					'id' => 'buy',
					'name' => 'покупка дополнения',
					'color' => '',
				),
			),
		),
		'action_data' => array(
			'type' => 'function',
			'name' => 'Детали',
			'sql' => true,
		),
		'lang_id' => array(
			'type' => 'select',
			'name' => 'Язык',
			'sql' => true,
			'no_important' => true,
		),
	);

	/**
	 * @var array поля для фильтра
	 */
	public $variables_filter = array(
		'created' => array(
			'type' => 'datetime_interval',
			'name' => 'Период',
			'links' => true,
		),
		'user_id' => array(
			'type' => 'none',
			'name' => 'Пользователь',
		),
		'module_name' => array(
			'type' => 'none',
			'name' => 'Модуль',
		),
		'element_type' => array(
			'type' => 'none',
			'name' => 'Тип элемента',
		),
		'element_id' => array(
			'type' => 'numtext',
			'name' => 'Номер элемента',
		),
		'action_name' => array(
			'type' => 'none',
			'name' => 'Действие',
		),
		'lang_id' => array(
			'type' => 'select',
			'name' => 'Язык',
		),
	);

	/**
	 * Подготавливает конфигурацию модуля
	 * @return void
	 */
	public function prepare_config()
	{
		if ($this->diafan->is_action('edit'))
		{
			Custom::inc('includes/404.php');
		}

		if ($items = DB::query_fetch_value("SELECT DISTINCT user_id FROM {".$this->table."}", 'user_id'))
		{
			$users = DB::query_fetch_key_value("SELECT id, CONCAT(fio, ' (', name, ')') as fio FROM {users} WHERE id IN (%s)", implode(',', $items), 'id', 'fio');
			$options = array();
			foreach ($items as $user_id)
			{
				$options[$user_id] = ! empty($users[$user_id]) ? $users[$user_id] : $user_id;
			}
			$this->diafan->variable_filter('user_id', 'type', 'select');
			$this->diafan->variable_filter('user_id', 'select', $options);
		}
		if ($module_names = DB::query_fetch_value("SELECT DISTINCT module_name FROM {".$this->table."} WHERE module_name<>''", 'module_name'))
		{
			$options = array();
			$options_list = array();
			foreach ($module_names as $module_name)
			{
				$module_title = ! empty($this->diafan->title_modules[$module_name]) ? $this->diafan->title_modules[$module_name] : $module_name;

				$options[$module_name] = $module_title;
				$options_list[$module_name] = array(
					'id' => $module_name,
					'name' => $module_title,
					'color' => '',
				);
			}
			$this->diafan->variable_list('module_name', 'select', $options_list);
			$this->diafan->variable_filter('module_name', 'type', 'select');
			$this->diafan->variable_filter('module_name', 'select', $options);
		}
		if ($items = DB::query_fetch_value("SELECT DISTINCT element_type FROM {".$this->table."} WHERE element_type<>''", 'element_type'))
		{
			$element_types = $this->diafan->variable_list('element_type', 'select');
			$options = array();
			foreach ($items as $element_type)
			{
				$options[$element_type] = ! empty($element_types[$element_type]) ? $element_types[$element_type]['name'] : $element_type;
				if (! empty($element_types[$element_type]['modules']))
				{
					foreach ($module_names as $module_name)
					{
						if (! empty($element_types[$element_type]['modules'][$module_name]))
						{
							$options[$module_name.'|'.$element_type] = $element_types[$element_type]['modules'][$module_name]['name'];
						}
					}
				}
			}
			$this->diafan->variable_filter('element_type', 'type', 'select');
			$this->diafan->variable_filter('element_type', 'select', $options);
		}
		if ($items = DB::query_fetch_value("SELECT DISTINCT action_name FROM {".$this->table."} WHERE action_name<>''", 'action_name'))
		{
			$action_names = $this->diafan->variable_list('action_name', 'select');
			$options = array();
			foreach ($items as $action_name)
			{
				$options[$action_name] = ! empty($action_names[$action_name]) ? $action_names[$action_name]['name'] : $action_name;
			}
			$this->diafan->variable_filter('action_name', 'type', 'select');
			$this->diafan->variable_filter('action_name', 'select', $options);
		}

		$options = array();
		foreach ($this->diafan->_languages->all as $lang)
		{
			$options[$lang['id']] = $lang['name'];
		}
		$this->diafan->variable_list('lang_id', 'select', $options);
	}

	/**
	 * Выводит список действий
	 * 
	 * @return void
	 */
	public function show()
	{
		$this->diafan->list_row();

		if (! $this->diafan->configmodules('history'))
		{
			echo '<div class="commentary">'.$this->diafan->_('Подключите опцию «Вести историю действий» в %sнастройках%s модуля.', '<a href="'.BASE_PATH_HREF.'users/config/">', '</a>').'</div>';
		}
		elseif (! $this->diafan->count)
		{
			echo '<p><b>'.$this->diafan->_('Пользовательская активность не наблюдалась.').'</b></p>';
		}
	}

	/**
	 * Поиск по типу элемента
	 *
	 * @param array $row информация о текущем поле
	 * @return mixed
	 */
	public function save_filter_variable_element_type($row)
	{
		if ($value = $this->diafan->filter($_GET, 'string', 'filter_element_type'))
		{
			$module_name = '';
			if (strpos($value, '|') === false)
			{
				$element_type = $value;
			}
			else
			{
				list($module_name, $element_type) = explode('|', $value, 2);
				if (! empty($_GET['filter_module_name']))
				{
					$module_name = '';
				}
			}
			if ($module_name)
			{
				$this->diafan->where .= " AND e.module_name='".$this->diafan->filter($module_name, 'sql')."'";
			}
			if ($element_type)
			{
				$this->diafan->where .= " AND e.element_type='".$this->diafan->filter($element_type, 'sql')."'";
			}
			$this->diafan->get_nav .= ($this->diafan->get_nav ? '&amp;' : '?') . 'filter_element_type='.$this->diafan->filter($_GET, 'url', 'filter_element_type');
		}
		return $value;
	}

	/**
	 * Выводит имя пользователя, совершившего действие
	 *
	 * @param array $row информация о текущем элементе списка
	 * @param array $var текущее поле
	 * @return string
	 */
	public function list_variable_user_id($row, $var)
	{
		if(! isset($this->cache["prepare"]["users"]))
		{
			$user_ids = array();
			foreach($this->diafan->rows as $r)
			{
				if($r["user_id"] && ! in_array($r["user_id"], $user_ids))
				{
					$user_ids[] = $r["user_id"];
				}
			}
			if($user_ids)
			{
				$this->cache["prepare"]["users"] = DB::query_fetch_key_value(
					"SELECT id, CONCAT(fio, ' (', name, ')') as fio FROM {users} WHERE id IN (%s) AND trash='0'",
					implode(",", $user_ids),
					"id", "fio"
				);
			}
		}
		$text = '<div>';
		if($row["user_id"] && ! empty($this->cache["prepare"]["users"][$row["user_id"]]))
		{
			$text .= '<a href="'.BASE_PATH_HREF.'users/edit'.$row["user_id"].'/">'.$this->cache["prepare"]["users"][$row["user_id"]].'</a>';
		}
		$text .= '</div>';
		return $text;
	}

	/**
	 * Выводит название модуля в списке
	 *
	 * @param array $row информация о текущем элементе списка
	 * @param array $var текущее поле
	 * @return string
	 */
	public function list_variable_module_name($row, $var)
	{
		$module_name = $row['module_name'];
		$module_names = $this->diafan->variable_list('module_name', 'select');
		if (! empty($module_names[$row['module_name']]))
		{
			$module_name = $module_names[$row['module_name']]['name'];
		}
		return '<div class="no_important">'.$module_name.'</div>';
	}

	/**
	 * Выводит тип элемента в списке
	 *
	 * @param array $row информация о текущем элементе списка
	 * @param array $var текущее поле
	 * @return string
	 */
	public function list_variable_element_type($row, $var)
	{
		$element_type = $row['element_type'];
		$element_types = $this->diafan->variable_list('element_type', 'select');
		if (! empty($element_types[$row['element_type']]))
		{
			$element_type = ! empty($element_types[$row['element_type']]['modules'][$row['module_name']]) ? $element_types[$row['element_type']]['modules'][$row['module_name']]['name'] : $element_types[$row['element_type']]['name'];
		}
		return '<div>'.$element_type.'</div>';
	}

	/**
	 * Выводит название действия в списке
	 *
	 * @param array $row информация о текущем элементе списка
	 * @param array $var текущее поле
	 * @return string
	 */
	public function list_variable_action_name($row, $var)
	{
		$action_name = $row['action_name'];
		$action_names = $this->diafan->variable_list('action_name', 'select');
		if (! empty($action_names[$row['action_name']]))
		{
			$action_name = ! empty($action_names[$row['element_type']]['modules'][$row['module_name']]) ? $action_names[$row['element_type']]['modules'][$row['module_name']]['name'] : $action_names[$row['action_name']]['name'];
		}
		return '<div>'.$action_name.'</div>';
	}

	/**
	 * Выводит данные действия в списке
	 *
	 * @param array $row информация о текущем элементе списка
	 * @param array $var текущее поле
	 * @return string
	 */
	public function list_variable_action_data($row, $var)
	{
		$handle = $row['module_name'].'_'.$row['action_name'].'_handle';
		return '<div class="no_important">'.(method_exists($this, $handle) ? $this->$handle($row) : $row['action_data']).'</div>';
	}

	/**
	 * Обрабатывает данные изменения статуса заказа
	 *
	 * @param array $row информация о текущем элементе списка
	 * @return string
	 */
	private function order_status_handle($row)
	{
		$text = '';
		//пример сериализации
		/* if (! empty($row['action_data']))
		{
			$data = @unserialize($row['action_data']);
			if (is_array($data) && ! empty($data['id']))
			{
				$status_id = $data['id'];
				if (! isset($this->cache['action_data']['order_status'][$status_id]))
				{
					$this->cache['action_data']['order_status'][$status_id] = DB::query_fetch_array("SELECT id, [name], color FROM {shop_order_status} WHERE id=%d", $status_id);
				}
				if (! empty($this->cache['action_data']['order_status'][$status_id]))
				{
					$text = $this->cache['action_data']['order_status'][$status_id]['name'];
				}
			}
		} */
		if ($status_id = $this->diafan->filter($row, 'int', 'action_data'))
		{
			if (! isset($this->cache['action_data']['order_status'][$status_id]))
			{
				$this->cache['action_data']['order_status'][$status_id] = DB::query_fetch_array("SELECT id, [name], color FROM {shop_order_status} WHERE id=%d", $status_id);
			}
			if (! empty($this->cache['action_data']['order_status'][$status_id]))
			{
				$text = $this->cache['action_data']['order_status'][$status_id]['name'];
			}
		}
		return $text;
	}
}
