<?php
/**
 * Заметки для событий
 * 
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2023 OOO «Диафан» (http://www.diafan.ru/)
 */

if (! defined('DIAFAN'))
{
	$path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}

/**
 * Users_admin_notice_dashboard
 */
class Users_admin_notice_dashboard extends Diafan
{
	/**
	 * @var string название таблицы
	 */
	public $name = '<i class="fa fa-sticky-note-o"></i> Все заметки';

	/**
	 * @var integer порядковый номер для сортировки
	 */
	public $sort = 0;

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'users_notice';

	/**
	 * @var string нет элементов
	 */
	public $empty_rows = 'Нет новых заметок.';
	
	/**
	 * @var string не выводить виджет
	 */
	public $disable_vidget = false;	

	/**
	 * @var string условие для отбора
	 */
	public $where = "act='1' AND trash='0'";

	/**
	 * Конструктор класса
	 *
	 * @return void
	 */
	public function __construct(&$diafan)
	{
		parent::__construct($diafan);
		
		$this->where .= " AND (user_id=".$this->diafan->_users->id." OR adresat_id=".$this->diafan->_users->id." OR adresat_id=0)";
	}

	/**
	 * @var array поля в таблице
	 */
	public $variables = array (
		'created' => array(
			'name' => 'Дата и время',
			'sql' => true,
		),
		'text' => array(
			'name' => 'Заметка',
			'sql' => true,
		),
		'rewrite' => array(
			'type' => 'none',
			'name' => 'Страница, на которой создана заметка',
			'sql' => true,
		),
		'element_id' => array(
			'type' => 'none',
			'name' => 'Номер элемента',
			'sql' => true,
		),
		'site_id' => array(
			'type' => 'none',
			'name' => 'Номер страницы',
			'sql' => true,
		),
	);

	/**
	 * Выводит адрес страницы
	 *
	 * @param array $row информация о текущем элементе списка
	 * @param array $var текущее поле
	 * @param array $rows все элементы
	 * 
	 * @return string
	 */
	public function list_variable_text($row, $var, $rows)
	{
		return '<div class="date">'.date('d.m.Y H:i', $row['created']).'</div><div class="text" style="word-break: break-word;"><a href="'.$this->get_url($row).'">'.$this->diafan->short_text($row['text']).'</a></div>';
	}

	/**
	 * Получает адрес страницы
	 *
	 * @param array $data данные
	 * 
	 * @return string
	 */
	private function get_url($data)
	{
		$url = BASE_PATH_HREF;
		if ($data['rewrite'])
		{
			$url .= $data['rewrite'].'/';
		}
		if ($data['site_id'])
		{
			$url .= 'site'.$data['site_id'].'/';
		}
		if ($data['element_id'])
		{
			$url .= 'edit'.$data['element_id'].'/';
		}
		return $url;
	}
}
