<?php
/**
 * Заметки пользователей
 * 
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2023 OOO «Диафан» (http://www.diafan.ru/)
 */

if (! defined('DIAFAN'))
{
	$path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}

/**
 * Users_admin_notice
 */
class Users_admin_notice extends Frame_admin
{
	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'users_notice';

	/**
	 * @var array поля в базе данных для редактирования
	 */
	public $variables = array (
		'main' => array (
			'created' => array(
				'type' => 'datetime',
				'name' => 'Дата',
				'disabled' => true,
				'no_save' => true,
				'help' => 'Дата создания заметки в формате дд.мм.гггг чч:мм.',
			),
			'text' => array(
				'type' => 'textarea',
				'name' => 'Заметка',
				'help' => 'Текст заметки.',
				'placeholder' => 'Текст заметки',
			),
			'act' => array(
				'type' => 'checkbox',
				'name' => 'Опубликовано',
				'default' => true,
			),
			'user_id' => array(
				'type' => 'function',
				'name' => 'От кого',
				'disabled' => true,
				'no_save' => true,
				'help' => 'Автор заметки.',
			),
			'adresat_id' => array(
				'type' => 'function',
				'name' => 'Кому',
				'help' => 'Адресат заметки.',
			),
			'rewrite' => array(
				'type' => 'none',
				'name' => 'Страница, на которой создана заметка',
				'disabled' => true,
				'no_save' => true,
				'help' => 'Адрес страницы, на которой пользователь создал заметку.',
			),
			'element_type' => array(
				'type' => 'none',
				'name' => 'Тип элемента',
				'disabled' => true,
				'no_save' => true,
				'select' => array(
					'element' => array(
						'id' => 'element',
						'name' => 'Элемент',
						'color' => '',
						'modules' => array(
							'site' => array(
								'name' => 'Страница',
							),
							'bs' => array(
								'name' => 'Баннер',
							),
							'news' => array(
								'name' => 'Новость',
							),
							'clauses' => array(
								'name' => 'Статья',
							),
							'photo' => array(
								'name' => 'Фотография',
							),
							'shop' => array(
								'name' => 'Товар',
							),
							'order' => array(
								'name' => 'Заказ',
							),
							'payment' => array(
								'name' => 'Способ оплаты',
							),
							'delivery' => array(
								'name' => 'Способ доставки',
							),
							'feedback' => array(
								'name' => 'Сообщение',
							),
							'users' => array(
								'name' => 'Пользователь',
							),
							'custom' => array(
								'name' => 'Тема',
							),
							'service' => array(
								'name' => 'Модуль',
							),
							'addons' => array(
								'name' => 'Дополнение',
							),
							'update' => array(
								'name' => 'Обновление',
							),
						),
					),
					'cat' => array(
						'id' => 'cat',
						'name' => 'Категория',
						'color' => '',
						'modules' => array(
							'photo' => array(
								'name' => 'Альбом',
							),
						),
					),
					'param' => array(
						'id' => 'param',
						'name' => 'Поле',
						'color' => '',
						'modules' => array(
							'shop' => array(
								'name' => 'Характеристика',
							),
						),
					),
					'brand' => array(
						'id' => 'brand',
						'name' => 'Производитель',
						'color' => '',
					),
					'config' => array(
						'id' => 'config',
						'name' => 'Настройки',
						'color' => '',
					),
					'theme' => array(
						'id' => 'theme',
						'name' => 'Настройки шаблона',
						'color' => '',
					),
					'blocks' => array(
						'id' => 'blocks',
						'name' => 'Блок',
						'color' => '',
					),
					'order_status' => array(
						'id' => 'order_status',
						'name' => 'Статус',
						'color' => '',
					),
					'history' => array(
						'id' => 'history',
						'name' => 'История',
						'color' => '',
					),
					'additional_cost' => array(
						'id' => 'additional_cost',
						'name' => 'Сопутствующая услуга',
						'color' => '',
					),
					'return' => array(
						'id' => 'return',
						'name' => 'Обновление',
						'color' => '',
					),
					'role' => array(
						'id' => 'role',
						'name' => 'Роль',
						'color' => '',
					),
					'notice' => array(
						'id' => 'notice',
						'name' => 'Заметка',
						'color' => '',
					),
					// 'currency' => 'Валюта',
					// 'backend' => 'Расширение',
					// 'wishlist' => 'Избранное',
					// 'waitlist' => 'Ожидание',
					// 'dynamic' => 'Динамический блок',
				),
			),
			'element_id' => array(
				'type' => 'none',
				'name' => 'Номер элемента',
				'disabled' => true,
				'no_save' => true,
			),
			'site_id' => array(
				'type' => 'none',
				'name' => 'Номер страницы',
				'disabled' => true,
				'no_save' => true,
			),
			'url' => array(
				'type' => 'function',
				'name' => 'Где',
				'no_save' => true,
				'disabled' => true,
			),
			// 'is_done' => array(
			// 	'type' => 'checkbox',
			// 	'name' => 'Решено',
			// ),
		),
	);

	/**
	 * @var array поля в списке элементов
	 */
	public $variables_list = array (
		'checkbox' => '',
		'created' => array(
			'name' => 'Дата и время',
			'type' => 'datetime',
			'sql' => true,
		),
		'name' => array(
			'name' => 'Заметка',
			'variable' => 'text',
		),
		'user_id' => array(
			'type' => 'function',
			'name' => 'От кого',
			'sql' => true,
		),
		'adresat_id' => array(
			'type' => 'function',
			'name' => 'Кому',
			'sql' => true,
		),
		'rewrite' => array(
			'type' => 'none',
			'name' => 'Страница, на которой создана заметка',
			'sql' => true,
		),
		'module_name' => array(
			'type' => 'none',
			'name' => 'Модуль',
			'sql' => true,
		),
		'element_type' => array(
			'type' => 'none',
			'name' => 'Тип элемента',
			'sql' => true,
		),
		'element_id' => array(
			'type' => 'none',
			'name' => 'Номер элемента',
			'sql' => true,
		),
		'site_id' => array(
			'type' => 'none',
			'name' => 'Номер страницы',
			'sql' => true,
		),
		'url' => array(
			'type' => 'function',
			'name' => 'Где',
			'no_important' => true,
		),
		// 'is_done' => array(
		// 	'type' => 'function',
		// 	'name' => 'Решено',
		// 	'sql' => true,
		// ),
		'actions' => array(
			'act' => true,
			'trash' => true,
		),
	);

	/**
	 * @var array поля для фильтра
	 */
	public $variables_filter = array(
		'created' => array(
			'type' => 'datetime_interval',
			'name' => 'Период',
			'links' => true,
		),
	);

	/**
	 * Подготавливает конфигурацию модуля
	 * @return void
	 */
	public function prepare_config()
	{

	}

	/**
	 * Выводит список действий
	 * 
	 * @return void
	 */
	public function show()
	{
		$this->diafan->list_row();

		if (! $this->diafan->count)
		{
			echo '<p><b>'.$this->diafan->_('Заметок нет.').'</b></p>';
		}
	}

	/**
	 * Формирует часть SQL-запрос для списка элементов, отвечающую за сортировку
	 *
	 * @return string
	 */
	public function sql_query_order()
	{
		return ' ORDER BY e.is_done ASC, e.act DESC, e.id DESC';
	}

	/**
	 * Выводит имя пользователя - автора заметки
	 *
	 * @param array $row информация о текущем элементе списка
	 * @param array $var текущее поле
	 * @return string
	 */
	public function list_variable_user_id($row, $var)
	{
		if (! isset($this->cache['users']))
		{
			$ids = array();
			foreach ($this->diafan->rows as $item)
			{
				if ($item['user_id'])
				{
					$ids[$item['user_id']] = $item['user_id'];
				}
				if ($item['adresat_id'])
				{
					$ids[$item['adresat_id']] = $item['adresat_id'];
				}
			}
			if ($ids)
			{
				$this->cache['users'] = DB::query_fetch_key_value("SELECT id, CONCAT(fio, ' (', name, ')') as fio FROM {users} WHERE id IN (%s) AND trash='0'", implode(',', $ids), 'id', 'fio');
			}
		}

		$user_id = '';
		if ($row['user_id'] && ! empty($this->cache['users'][$row['user_id']]))
		{
			$user_id .= '<a href="'.BASE_PATH_HREF.'users/edit'.$row['user_id'].'/">'.($row['user_id'] == $this->diafan->_users->id ? $this->diafan->_('Я') : $this->cache['users'][$row['user_id']]).'</a>';
		}
		return '<div class="no_important">'.$user_id.'</div>';
	}

	/**
	 * Выводит имя пользователя - адресата заметки
	 *
	 * @param array $row информация о текущем элементе списка
	 * @param array $var текущее поле
	 * @return string
	 */
	public function list_variable_adresat_id($row, $var)
	{
		$adresat_id = '';
		if ($row['adresat_id'] && ! empty($this->cache['users'][$row['adresat_id']]))
		{
			$adresat_id .= '<a href="'.BASE_PATH_HREF.'users/edit'.$row['adresat_id'].'/">'.($row['adresat_id'] == $this->diafan->_users->id ? $this->diafan->_('Мне') : $this->cache['users'][$row['adresat_id']]).'</a>';
		}
		return '<div class="no_important">'.($adresat_id ? $adresat_id : 'Всем').'</div>';
	}

	/**
	 * Выводит адрес страницы
	 *
	 * @param array $row информация о текущем элементе списка
	 * @param array $var текущее поле
	 * @return string
	 */
	public function list_variable_url($row, $var)
	{
		return '<div class="no_important"><a href="'.$this->get_url($row).'">'.$this->get_url_name($row).'</a></div>';
	}

	/**
	 * 
	 * 
	 * @return void
	 */
	public function edit_variable_adresat_id()
	{
		if ($this->diafan->value)
		{
			$this->diafan->value = '<a href="'.BASE_PATH_HREF.'users/edit'.$this->diafan->value.'/">'.DB::query_result("SELECT CONCAT(fio, ' (', name, ')') FROM {users} WHERE id=%d LIMIT 1", $this->diafan->value).'</a>';
		}
		else
		{
			$this->diafan->value = $this->diafan->_('Всем');
		}

		$this->diafan->show_table_tr(
			'string',
			$this->diafan->key,
			$this->diafan->value,
			$this->diafan->variable_name(),
			$this->diafan->help(),
			$this->diafan->variable_disabled(),
			$this->diafan->variable('', 'maxlength'),
			$this->diafan->variable('', 'select'),
			$this->diafan->variable('', 'select_db'),
			$this->diafan->variable('', 'depend'),
			$this->diafan->variable('', 'attr')
		);
	}

	public function edit_variable_rewrite() {}
	public function validate_variable_rewrite() {}
	public function save_variable_rewrite() {}
	public function edit_variable_site_id() {}
	public function validate_variable_site_id() {}
	public function save_variable_site_id() {}

	/**
	 * Выводит адрес страницы
	 *
	 * @param array $row информация о текущем элементе списка
	 * @param array $var текущее поле
	 * @return string
	 */
	public function edit_variable_url()
	{
		$data = array(
			'rewrite' => $this->diafan->values('rewrite'),
			'module_name' => $this->diafan->values('module_name'),
			'element_type' => $this->diafan->values('element_type'),
			'element_id' => $this->diafan->values('element_id'),
			'site_id' => $this->diafan->values('site_id'),
		);

		$this->diafan->value = '<a href="'.$this->get_url($data).'">'.$this->get_url_name($data).'</a>';

		$this->diafan->show_table_tr(
			'string',
			$this->diafan->key,
			$this->diafan->value,
			$this->diafan->variable_name(),
			$this->diafan->help(),
			$this->diafan->variable_disabled(),
			$this->diafan->variable('', 'maxlength'),
			$this->diafan->variable('', 'select'),
			$this->diafan->variable('', 'select_db'),
			$this->diafan->variable('', 'depend'),
			$this->diafan->variable('', 'attr')
		);
	}

	/**
	 * Получает адрес страницы
	 *
	 * @param array $data данные
	 * 
	 * @return string
	 */
	private function get_url($data)
	{
		$url = BASE_PATH_HREF;
		if ($data['rewrite'])
		{
			$url .= $data['rewrite'].'/';
		}
		if ($data['site_id'])
		{
			$url .= 'site'.$data['site_id'].'/';
		}
		if ($data['element_id'])
		{
			$url .= 'edit'.$data['element_id'].'/';
		}
		return $url;
	}

	/**
	 * Получает наименование страницы
	 *
	 * @param array $data данные
	 * 
	 * @return string
	 */
	private function get_url_name($data)
	{
		$name = $data['element_type'];
		if ($data['element_id'])
		{
			$element_types = $this->diafan->variable('element_type', 'select');
			if (! empty($element_types[$data['element_type']]))
			{
				if (! empty($element_types[$data['element_type']]['modules'][$data['module_name']]))
				{
					$name = $element_types[$data['element_type']]['modules'][$data['module_name']]['name'];
				}
				else
				{
					$name = $element_types[$data['element_type']]['name'];
				}
			}
			$name .= ' (ID: '.$data['element_id'].')';
		}
		elseif ($data['element_type'] == 'element' && ! empty($this->diafan->title_modules[$data['module_name']]))
		{
			$name = $this->diafan->title_modules[$data['module_name']];
		}
		elseif ($admin_name = DB::query_result("SELECT name FROM {admin} WHERE BINARY rewrite='%h' ORDER BY parent_id DESC", $data['rewrite']))
		{
			$name = $admin_name;
		}
		return $name;
	}

	/**
	 * Выводит флаг готовности
	 *
	 * @param array $row информация о текущем элементе списка
	 * @param array $var текущее поле
	 * @return string
	 */
	public function list_variable_is_done($row, $var)
	{
		return '<div class="no_important">'.(! empty($row['is_done']) ? '<i class="fa fa-check-square" aria-hidden="true"></i>' : '').'</div>';
	}
}
