/**
 * JS-сценарий виджета
 *
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2023 OOO «Диафан» (http://www.diafan.ru/)
 */



$(function () {

	var $widget = $('.widget-d_notice');

	$('._scroll_bottom', $widget).each(function (i, node) {
		$(node).animate({ scrollTop: node.scrollHeight });
	});
	$('.notices-d__form textarea', $widget).on('keyup', function (e) {
		if (e.ctrlKey && e.keyCode == 13) $('.j-notice-create', $widget).click();
	});

	$widget.on('click', '.j-notice-create', function(e) {
		e.preventDefault();
		var $button = $(this);
		var $form = $button.closest('form');
		diafan_ajax.init({
			data: {
				module: 'users',
				widget: 'notice',
				action: 'create',
				adresat_id: $('[name=adresat_id]', $form).val(),
				text: $('[name=text]', $form).val(),
				rewrite: $('[name=rewrite]', $form).val(),
				module_name: $('[name=module_name]', $form).val(),
				element_type: $('[name=element_type]', $form).val(),
				element_id: $('[name=element_id]', $form).val(),
				site_id: $('[name=site_id]', $form).val(),
			},
			before: function() {
				$(':submit', $form).attr('disabled', 'disabled');
				$('.errors', $form).empty();
				$('.error_input', $form).removeClass('error_input');
			},
			success: function(response) {
				$(':submit', $form).removeAttr('disabled');
				if (response)
				{
					if (response.result === 'success')
					{
						$('.notices-d__list', $widget).html(prepare(response.rows));
						$('._scroll_bottom', $widget).each(function (i, node) {
							$(node).animate({ scrollTop: node.scrollHeight });
						});

						if (response.num)
						{
							$('.launchitem-d__num', $widget).text(response.num).show();
							$('.toolitem-d_hide', $widget).show();
						}
						else
						{
							$('.launchitem-d__num', $widget).empty();
							$('.toolitem-d_hide', $widget).hide();
						}
						// $form.clearForm();
						$('textarea', $form).val('').trigger('input');
					}
					else if (response.errors)
					{
						$.each(response.errors, function (k, val) {
							if (k == 0)
							{
								if (! $('.error', $form).length)
								{
									$('.error', $form.parent()).addClass('error_message').html(prepare(val)).show();
								}
								else
								{
									$('.error', $form).addClass('error_message').html(prepare(val)).show();
								}
							}
							else
							{
								var input = $("input[name="+k+"], textarea[name="+k+"], select[name="+k+"]", $form);
								$('.error_' + k, $form).addClass('error_message').html(prepare(val)).show();
								if (input.length)
								{
									input.addClass('error_input').addClass('focus_input');
								}
							}
						});
						$('.focus_input:first', $form).focus();
						$('.focus_input', $form).removeClass('focus_input');
					}
				}
			}
		});
		return false;
	});

	$widget.on('click', '.toolitem-d_hide', function (e) {
		e.preventDefault();
		var $toolitem = $(this);
		var $form = $('.notices-d__form', $widget);
		diafan_ajax.init({
			data: {
				module: 'users',
				widget: 'notice',
				action: 'hide',
				rewrite: $('[name=rewrite]', $form).val(),
				module_name: $('[name=module_name]', $form).val(),
				element_type: $('[name=element_type]', $form).val(),
				element_id: $('[name=element_id]', $form).val(),
				site_id: $('[name=site_id]', $form).val(),
			},
			before: function() {
				$toolitem.attr('disabled', 'disabled');
			},
			success: function(response) {
				$toolitem.removeAttr('disabled');
				if (response)
				{
					if (response.result === 'success')
					{
						$widget.removeClass('widget-d_active');
						$('.launchitem-d__num', $widget).empty();
						$('.launchitem-d_active', $widget).removeClass('launchitem-d_active');
						$('.notices-d__list', $widget).empty();
						$('textarea', $form).val('').trigger('input');
						$toolitem.hide();
					}
				}
			}
		});
		return false;
	});

	function tune_scroll(container)
	{
		var scroll_width = 0;
		if (container.scrollHeight > container.clientHeight)
		{
			scroll_width = container.offsetWidth - container.clientWidth;
			if (!scroll_width) scroll_width = 20;
		}
		if (scroll_width) scroll_width += 3;
		container.style.paddingRight = scroll_width + 'px';
		// $list.toggleClass('notices-d__list_scroll', container.scrollHeight > container.clientHeight);
	}
	// $('._scroll').each(function (i, node) {
	// 	tune_scroll(node);
	// });

});
