<?php
/**
 * Обработка POST-запросов виджета
 *
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2023 OOO «Диафан» (http://www.diafan.ru/)
 */
if ( ! defined('DIAFAN'))
{
	$path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}



class Users_admin_widget_notice_action extends Diafan
{
	/**
	 * @var array — результат, полученный после обработки данных
	 */
	public $result = array();

	/**
	 * Вызывает обработку POST-запросов
	 *
	 * @return void
	 */
	public function init()
	{
		if (! empty($_POST['action']))
		{
			switch ($_POST['action'])
			{
				case 'create':
					$this->create();
					break;

				case 'hide':
					$this->hide();
					break;
			}
		}
	}

	/**
	 * Создаёт заметку
	 *
	 * @return void
	 */
	private function create()
	{
		if (empty($_POST['text']))
		{
			$this->result['errors']['text'] = 'Введите текст заметки';
			return;
		}
		$rewrite = $this->diafan->filter($_POST, 'string', 'rewrite');
		if (! $rewrite || ! $this->diafan->_users->roles('init', $rewrite))
		{
			$this->result['errors'][0] = 'Страница недоступна для заметок';
			return;
		}
		$adresat_id = $this->diafan->filter($_POST, 'int', 'adresat_id');
		$module_name = $this->diafan->filter($_POST, 'string', 'module_name');
		$element_type = $this->diafan->filter($_POST, 'string', 'element_type');
		$element_id = $this->diafan->filter($_POST, 'int', 'element_id');
		$site_id = $this->diafan->filter($_POST, 'int', 'site_id');
		// $is_done = ! empty($_POST['is_done']) ? 1 : 0;
		$is_done = 0;

		DB::query("INSERT INTO {users_notice} (user_id, adresat_id, `text`, act, is_done, rewrite, module_name, element_type, element_id, site_id, created) VALUES (%d, %d, '%s', '1', '%d', '%h', '%h', '%h', %d, %d, %d)",
		$this->diafan->_users->id, $adresat_id, $_POST['text'], $is_done, $rewrite, $module_name, $element_type, $element_id, $site_id, time());

		DB::query("UPDATE {users_notice} SET is_done='0', act='1' WHERE act='0' AND trash='0' AND rewrite='%h' AND module_name='%h' AND element_type='%h' AND element_id=%d AND site_id=%d",
		$rewrite, $module_name, $element_type, $element_id, $site_id);

		$this->result['num'] = 0;
		$this->result['rows'] = '';
		if (Custom::exists('modules/users/admin/widget/notice/users.admin.widget.notice.php'))
		{
			Custom::inc('modules/users/admin/widget/notice/users.admin.widget.notice.php');
			$class_name = 'Users_admin_widget_notice';
			$widget = new $class_name($this->diafan, array(
				'id' => 0,
				'name' => 'Заметки',
				'widget' => 'notice',
				'module_name' => 'users',
				'params' => '',
			));
			$result = $widget->fetch($rewrite, $module_name, $element_type, $element_id, $site_id);
			$this->result['num'] = $result['count'];
			$this->result['rows'] = $widget->view('rows', $result);
		}

		$this->result['result'] = 'success';
	}

	/**
	 * Помечает заметки
	 *
	 * @return void
	 */
	private function hide()
	{
		$rewrite = $this->diafan->filter($_POST, 'string', 'rewrite');
		if (! $rewrite || ! $this->diafan->_users->roles('init', $rewrite))
		{
			$this->result['errors'][0] = 'Страница недоступна для заметок';
			return;
		}
		$module_name = $this->diafan->filter($_POST, 'string', 'module_name');
		$element_type = $this->diafan->filter($_POST, 'string', 'element_type');
		$element_id = $this->diafan->filter($_POST, 'int', 'element_id');
		$site_id = $this->diafan->filter($_POST, 'int', 'site_id');

		DB::query("UPDATE {users_notice} SET is_done='1', act='0' WHERE act='1' AND trash='0' AND rewrite='%h' AND module_name='%h' AND element_type='%h' AND element_id=%d AND site_id=%d",
		$rewrite, $module_name, $element_type, $element_id, $site_id);

		$this->result['result'] = 'success';
	}
}
