<?php
/**
 * Файл-блок шаблона
 *
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2020 OOO «Диафан» (http://www.diafan.ru/)
 */

?>



<?php if ($this->diafan->_site->theme('show_subscription') && $this->diafan->_site->module != 'shop' && $this->diafan->_site->module != 'cart')
{
	//шаблонный тег вывода формы для подписчиков. Вид блока редактируется в файле modules/subscription/views/subscription.view.form_main.php
	echo '<section class="page-d__subscript page-d__subscript_main">
		<insert name="show_form" module="subscription" template="main" defer="emergence" defer_title="Подписаться на рассылку">
	</section>';
}
if ($this->diafan->_site->theme('show_menu_bottom'))
{
	//шаблонный тег вывода третьего меню (параметр id=3). Настраивается в файле modules/menu/views/menu.view.show_block_nav_broad.php
	//Документация тега http://www.diafan.ru/dokument/full-manual/templates-functions/#show_block_menu
	echo '<section class="page-d__nav page-d__nav_broad">
		<insert name="show_block" module="menu" id="3" template="nav_broad">
	</section>';
}
?>

<footer class="page-d__foot">
	<div class="foot-d _box">
		<div class="foot-d__item foot-d__contacts">
			<?php if ($this->diafan->_site->theme('contacts'))
			{
				echo '<div class="foot-d__title"><insert value="Контакты"></div>
				<insert name="show_theme" module="site" tag="contacts">';
			}
			?>
		</div>
		<nav class="foot-d__item foot-d__nav">
			<?php if ($this->diafan->_site->theme('show_menu_footer'))
			{
				//шаблонный тег вывода первого меню (параметр id=1). Настраивается в файле modules/menu/views/menu.view.show_menu.php, так как параметр template не был передан. Тогда в оформлении используются параметры tag
				//Документация тега http://www.diafan.ru/dokument/full-manual/templates-functions/#show_block_menu -->
				echo '<div class="foot-d__title"><insert value="О магазине"></div>
				<insert name="show_block" module="menu"
						id="1"
						count_level="1"
						tag_level_start_1="[div class=\'nav-d _underline\'][ul class=\'menu-d nav-d__menu\']"
						tag_start_1="[li class=\'item-d\']"
						tag_end_1="[/li]"
						tag_level_end_1="[/ul][/div]"
						>';
			}
			?>
		</nav>
		<div class="foot-d__item foot-d__icons">
			<?php if ($this->diafan->_site->theme('show_socnets'))
			{
				//шаблонный тег вывода кнопок социальных сетей. Правится в файле 
				echo '<div class="foot-d__socnets">
					<div class="foot-d__title"><insert value="Мы в соцсетях"></div>
					<insert name="show_theme" module="site" tag="show_socnets" template="socnets">
				</div>';
			}
			if ($this->diafan->_site->theme('show_payments'))
			{
				echo '<div class="foot-d__payments">
					<div class="foot-d__title"><insert value="Принимаем к оплате"></div>
					<insert name="show_theme" module="site" tag="show_payments" template="payments">
				</div>';
			}
			?>
		</div>
		<div class="foot-d__item foot-d__website">
			<div class="website-d">
				<?php if ($this->diafan->_site->theme('copyright'))
				{
					echo '<div class="website-d__item website-d__copyright">&copy; <insert name="show_year">
						<insert name="show_theme" module="site" tag="copyright" template="nl2br">
					</div>';
				}
				if ($this->diafan->_site->theme('show_diafan'))
				{
					//шаблонный тег подключает файл-блок
					echo '<div class="website-d__item website-d__cms">
						<insert name="show_include" file="diafan">
					</div>';
				}
				if ($this->diafan->_site->theme('show_sitemap'))
				{
					//шаблонный тег show_href выведет ссылку на карту сайта <a href="/map/"><img src="/img/map.png"></a>, на странице карты сайта тег выведет активную иконку
					echo '<div class="website-d__item website-d__sitemap">
						<span class="icon-d fas fa-list"></span> <insert name="show_href" rewrite="map" alt="Карта сайта">
					</div>';
				}
				?>
			</div>
		</div>
	</div>
</footer>