<?php
/**
 * Файл-блок шаблона
 *
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2020 OOO «Диафан» (http://www.diafan.ru/)
 */

?>



<section class="page-d__hpanel">
	<div class="hpanel-d _box">
		<?php if ($this->diafan->_site->theme('show_menu_top'))
		{
			//шаблонный тег вывода первого меню (параметр id=1). Настраивается в файле modules/menu/views/menu.view.show_block_nav_top.php
			//Документация тега http://www.diafan.ru/dokument/full-manual/templates-functions/#show_block_menu -->
			echo '<div class="hpanel-d__nav">
				<insert name="show_block" module="menu" id="1" template="nav_top">
			</div>';
		}
		if ($this->diafan->_site->theme('show_langs'))
		{
			//шаблонный тег вывода блока ссылок на разные языковые версии сайта. Вид формы редактируется в файле modules/languages/views/languages.view.show_block.php
			echo '<div class="hpanel-d__langs">
				<insert name="show_block" module="languages">
			</div>';
		}
		if ($this->diafan->_site->theme('email') || $this->diafan->_site->theme('email2') || $this->diafan->_site->theme('phone') || $this->diafan->_site->theme('phone2'))
		{
			echo '<div class="hpanel-d__contacts contacts-d">';
			if ($this->diafan->_site->theme('email') || $this->diafan->_site->theme('email2'))
			{
				echo '<div class="contact-d contact-d_email contact-d_tooltip">
					<div class="contact-d__icon icon-d fas fa-envelope-open"></div>
					<div class="contact-d__list">
						<insert name="show_theme" module="site" tag="email" template="email">
						<insert name="show_theme" module="site" tag="email2" template="nl2br">
					</div>
				</div>';
			}
			if ($this->diafan->_site->theme('phone') || $this->diafan->_site->theme('phone2'))
			{
				echo '<div class="contact-d contact-d_phone contact-d_tooltip">
					<div class="contact-d__icon icon-d fas fa-phone"></div>
					<div class="contact-d__list">
						<insert name="show_theme" module="site" tag="phone" template="phone">
						<insert name="show_theme" module="site" tag="phone2" template="nl2br">
					</div>
				</div>';
			}
			echo '</div>';
		}
		?>
	</div>
</section>

<header class="page-d__hboard">
	<div class="hboard-d _box">
		<div class="hboard-d__signboard"><insert name="show_theme" module="site" tag="logo" template="logo"></div>
		<?php if ($this->diafan->_site->theme('show_search'))
		{
			//шаблонный тег вывода формы поиска. Вид формы редактируется в файле modules/search/views/search.view.show_search.php
			echo '<div class="hboard-d__search">
				<insert name="show_search" module="search" template="top">
			</div>';
		}
		if ($this->diafan->_site->theme('show_lk'))
		{
			//шаблонный тег вывода формы входа и регистрации пользователей. Вид формы редактируется в файле modules/registration/views/registration.view.show_login_top.php
			echo '<div class="hboard-d__auth">
				<insert name="show_login" module="registration" template="top">
			</div>';
		}
		if ($this->diafan->_site->theme('show_compare') || $this->diafan->_site->theme('show_wishlist') || $this->diafan->_site->theme('show_cart'))
		{
			echo '<div class="hboard-d__intercaps intercaps-d">';
			if ($this->diafan->_site->theme('show_compare'))
			{
				//шаблонный тег вывода количества товаров в сравнении. Вид формы редактируется в файле modules/shop/views/shop.view.show_compare_block.php
				echo '<insert name="show_compare_block" module="shop">';
			}
			if ($this->diafan->_site->theme('show_wishlist'))
			{
				//шаблонный тег вывода количества отложенных товаров. Вид формы редактируется в файле modules/wishlist/views/wishlist.view.show_block.php
				echo '<insert name="show_block" module="wishlist">';
			}
			if ($this->diafan->_site->theme('show_cart'))
			{
				//шаблонный тег вывода формы корзины. Вид формы редактируется в файле modules/cart/views/cart.view.show_block.php
				echo '<insert name="show_block" module="cart">';
			}
			echo '</div>';
		}
		?>
	</div>
</header>

<section class="page-d__nav page-d__nav_main">
	<!-- шаблонный тег вывода второго меню (параметр id=2). Настраивается в файле modules/menu/views/menu.view.show_block_nav_main.php
	Документация тега http://www.diafan.ru/dokument/full-manual/templates-functions/#show_block_menu -->
	<insert name="show_block" module="menu" id="2" template="nav_main">
</section>