<?php
/**
 * Шаблон страницы сайта, назначенной по умолчанию как стартовая для сайта
 *
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    7.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2020 OOO «Диафан» (http://www.diafan.ru/)
 */

if(! defined("DIAFAN"))
{
	$path = __FILE__;
	while(! file_exists($path.'/includes/404.php'))
	{
		$parent = dirname($path);
		if($parent == $path) exit;
		$path = $parent;
	}
	include $path.'/includes/404.php';
}
?><!DOCTYPE html>
<html lang="ru">
<head>
	<!-- Полный справочник по шаблонным тегам в документации:  https://www.diafan.ru/dokument/full-manual/templates-functions/ -->

	<!-- шаблонный тег подключает файл-блок blocks/head.php -->
	<insert name="show_include" file="head">
</head>
<body class="_loading">

<div class="page-d page-d_home">

	<!-- шаблонный тег подключает файл-блок blocks/header.php -->
	<insert name="show_include" file="header">

	<!-- параметр show_slider (показывать слайдер) из модуля «Настройки шаблона» -->
	<?php if ($this->diafan->_site->theme('show_slider'))
	{
		//шаблонный тег вывода баннеров. Блок выводит баннеры слайдера. Вид блока редактируется в файле modules/bs/views/bs.view.show_block_slider_main.php
		echo '<insert name="show_block" module="bs" count="3" cat_id="1" template="slider_main">';
	}
	?>
	<section class="page-d__content content-d _box">
		<main class="content-d__main">
			<?php if ($this->diafan->_site->theme('show_catalog'))
			{
				//шаблонный тег вывода блока некоторых товаров из магазина. Вид блока товаров редактируется в файле modules/shop/views/shop.view.show_block.php
				echo '<insert name="show_block" module="shop" count="4" images="1" sort="rand" template="gall" defer="emergence" defer_title="Интернет-магазин">';
			}
			if ($this->diafan->_site->theme('show_action'))
			{
				//шаблонный тег вывода блока некоторых товаров из магазина. Вид блока товаров редактируется в файле modules/shop/views/shop.view.show_block.php
				echo '<insert name="show_block" module="shop" action_only="true" count="4" images="1" sort="rand" template="gall" defer="emergence" defer_title="Интернет-магазин">';
			}
			if ($this->diafan->_site->theme('show_new'))
			{
				//шаблонный тег вывода блока некоторых товаров из магазина. Вид блока товаров редактируется в файле modules/shop/views/shop.view.show_block.php
				echo '<insert name="show_block" module="shop" new_only="true" count="4" images="1" sort="rand" template="gall" defer="emergence" defer_title="Интернет-магазин">';
			}
			if ($this->diafan->_site->theme('show_hit'))
			{
				//шаблонный тег вывода блока некоторых товаров из магазина. Вид блока товаров редактируется в файле modules/shop/views/shop.view.show_block.php
				echo '<insert name="show_block" module="shop" hits_only="true" count="4" images="1" sort="rand" template="gall" defer="emergence" defer_title="Интернет-магазин">';
			}
			if ($this->diafan->_site->theme('show_content'))
			{
				//шаблонный тег вывода основного контента сайта
				echo '<insert name="show_body">';
			}
			if ($this->diafan->_site->theme('show_banners'))
			{
				//шаблонный тег вывода баннеров. Блок выводит все баннеры. Вид блока редактируется в файле modules/bs/views/bs.view.show_block.php
				echo '<insert name="show_block" module="bs" count="2" cat_id="2" template="banners">';
			}
			if ($this->diafan->_site->theme('show_clauses'))
			{
				//шаблонный тег вывода блока статей. Вид блока статей редактируется в файле modules/clauses/views/clauses.view.show_block.php
				echo '<insert name="show_block" module="clauses" count="4" images="1" template="gall" defer="emergence" defer_title="Статьи">';
			}
			
			if ($this->diafan->_site->theme('show_comments'))
			{
				//шаблонный тег вывода блока последних комментариев на сайте сайта. Вид блока редактируется в файле modules/comments/views/comments.view.show_block.php
				echo '<insert name="show_block" module="comments" defer="emergence" defer_title="Последние комментарии">';
			}
			if ($this->diafan->_site->theme('show_faq'))
			{
				//шаблонный тег вывода блока вопросов и ответов сайта. Вид блока редактируется в файле modules/faq/views/faq.view.show_block.php
				echo '<insert name="show_block" module="faq" count="2" often="0" defer="emergence" defer_title="Вопрос-Ответ">';
			}
			?>
		</main>

		<!-- шаблонный тег подключает файл-блок blocks/left.php -->
		<insert name="show_include" file="left">
	</section>

	<!-- шаблонный тег подключает файл-блок blocks/footer.php -->
	<insert name="show_include" file="footer">
</div>

<!-- шаблонный тег подключает файл-блок blocks/bottom.php -->
<insert name="show_include" file="bottom">
</body>
</html>